
/* Scanner skeleton version:
 * $Header: /home/daffy/u0/vern/flex/RCS/flex.skl,v 2.91 96/09/10 16:58:48 vern Exp $
 */

#define FLEX_SCANNER
#define YY_FLEX_MAJOR_VERSION 2
#define YY_FLEX_MINOR_VERSION 5

#include <stdio.h>


/* cfront 1.2 defines "c_plusplus" instead of "__cplusplus" */
#ifdef c_plusplus
#ifndef __cplusplus
#define __cplusplus
#endif
#endif


#ifdef __cplusplus

#include <stdlib.h>

/* Use prototypes in function declarations. */
#define YY_USE_PROTOS

/* The "const" storage-class-modifier is valid. */
#define YY_USE_CONST

#else	/* ! __cplusplus */

#if __STDC__

#define YY_USE_PROTOS
#define YY_USE_CONST

#endif	/* __STDC__ */
#endif	/* ! __cplusplus */

#ifdef __TURBOC__
 #pragma warn -rch
 #pragma warn -use
#include <io.h>
#include <stdlib.h>
#define YY_USE_CONST
#define YY_USE_PROTOS
#endif

#ifdef YY_USE_CONST
#define yyconst const
#else
#define yyconst
#endif


#ifdef YY_USE_PROTOS
#define YY_PROTO(proto) proto
#else
#define YY_PROTO(proto) ()
#endif

/* Returned upon end-of-file. */
#define YY_NULL 0

/* Promotes a possibly negative, possibly signed char to an unsigned
 * integer for use as an array index.  If the signed char is negative,
 * we want to instead treat it as an 8-bit unsigned char, hence the
 * double cast.
 */
#define YY_SC_TO_UI(c) ((unsigned int) (unsigned char) c)

/* Enter a start condition.  This macro really ought to take a parameter,
 * but we do it the disgusting crufty way forced on us by the ()-less
 * definition of BEGIN.
 */
#define BEGIN yy_start = 1 + 2 *

/* Translate the current start state into a value that can be later handed
 * to BEGIN to return to the state.  The YYSTATE alias is for lex
 * compatibility.
 */
#define YY_START ((yy_start - 1) / 2)
#define YYSTATE YY_START

/* Action number for EOF rule of a given start state. */
#define YY_STATE_EOF(state) (YY_END_OF_BUFFER + state + 1)

/* Special action meaning "start processing a new file". */
#define YY_NEW_FILE yyrestart( yyin )

#define YY_END_OF_BUFFER_CHAR 0

/* Size of default input buffer. */
#define YY_BUF_SIZE 16384

typedef struct yy_buffer_state *YY_BUFFER_STATE;

extern int yyleng;
extern FILE *yyin, *yyout;

#define EOB_ACT_CONTINUE_SCAN 0
#define EOB_ACT_END_OF_FILE 1
#define EOB_ACT_LAST_MATCH 2

/* The funky do-while in the following #define is used to turn the definition
 * int a single C statement (which needs a semi-colon terminator).  This
 * avoids problems with code like:
 *
 * 	if ( condition_holds )
 *		yyless( 5 );
 *	else
 *		do_something_else();
 *
 * Prior to using the do-while the compiler would get upset at the
 * "else" because it interpreted the "if" statement as being all
 * done when it reached the ';' after the yyless() call.
 */

/* Return all but the first 'n' matched characters back to the input stream. */

#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		*yy_cp = yy_hold_char; \
		YY_RESTORE_YY_MORE_OFFSET \
		yy_c_buf_p = yy_cp = yy_bp + n - YY_MORE_ADJ; \
		YY_DO_BEFORE_ACTION; /* set up yytext again */ \
		} \
	while ( 0 )

#define unput(c) yyunput( c, yytext_ptr )

/* The following is because we cannot portably get our hands on size_t
 * (without autoconf's help, which isn't available because we want
 * flex-generated scanners to compile on their own).
 */
typedef unsigned int yy_size_t;


struct yy_buffer_state
	{
	FILE *yy_input_file;

	char *yy_ch_buf;		/* input buffer */
	char *yy_buf_pos;		/* current position in input buffer */

	/* Size of input buffer in bytes, not including room for EOB
	 * characters.
	 */
	yy_size_t yy_buf_size;

	/* Number of characters read into yy_ch_buf, not including EOB
	 * characters.
	 */
	int yy_n_chars;

	/* Whether we "own" the buffer - i.e., we know we created it,
	 * and can realloc() it to grow it, and should free() it to
	 * delete it.
	 */
	int yy_is_our_buffer;

	/* Whether this is an "interactive" input source; if so, and
	 * if we're using stdio for input, then we want to use getc()
	 * instead of fread(), to make sure we stop fetching input after
	 * each newline.
	 */
	int yy_is_interactive;

	/* Whether we're considered to be at the beginning of a line.
	 * If so, '^' rules will be active on the next match, otherwise
	 * not.
	 */
	int yy_at_bol;

	/* Whether to try to fill the input buffer when we reach the
	 * end of it.
	 */
	int yy_fill_buffer;

	int yy_buffer_status;
#define YY_BUFFER_NEW 0
#define YY_BUFFER_NORMAL 1
	/* When an EOF's been seen but there's still some text to process
	 * then we mark the buffer as YY_EOF_PENDING, to indicate that we
	 * shouldn't try reading from the input source any more.  We might
	 * still have a bunch of tokens to match, though, because of
	 * possible backing-up.
	 *
	 * When we actually see the EOF, we change the status to "new"
	 * (via yyrestart()), so that the user can continue scanning by
	 * just pointing yyin at a new input file.
	 */
#define YY_BUFFER_EOF_PENDING 2
	};

static YY_BUFFER_STATE yy_current_buffer = 0;

/* We provide macros for accessing buffer states in case in the
 * future we want to put the buffer states in a more general
 * "scanner state".
 */
#define YY_CURRENT_BUFFER yy_current_buffer


/* yy_hold_char holds the character lost when yytext is formed. */
static char yy_hold_char;

static int yy_n_chars;		/* number of characters read into yy_ch_buf */


int yyleng;

/* Points to current character in buffer. */
static char *yy_c_buf_p = (char *) 0;
static int yy_init = 1;		/* whether we need to initialize */
static int yy_start = 0;	/* start state number */

/* Flag which is used to allow yywrap()'s to do buffer switches
 * instead of setting up a fresh yyin.  A bit of a hack ...
 */
static int yy_did_buffer_switch_on_eof;

void yyrestart YY_PROTO(( FILE *input_file ));

void yy_switch_to_buffer YY_PROTO(( YY_BUFFER_STATE new_buffer ));
void yy_load_buffer_state YY_PROTO(( void ));
YY_BUFFER_STATE yy_create_buffer YY_PROTO(( FILE *file, int size ));
void yy_delete_buffer YY_PROTO(( YY_BUFFER_STATE b ));
void yy_init_buffer YY_PROTO(( YY_BUFFER_STATE b, FILE *file ));
void yy_flush_buffer YY_PROTO(( YY_BUFFER_STATE b ));
#define YY_FLUSH_BUFFER yy_flush_buffer( yy_current_buffer )

YY_BUFFER_STATE yy_scan_buffer YY_PROTO(( char *base, yy_size_t size ));
YY_BUFFER_STATE yy_scan_string YY_PROTO(( yyconst char *yy_str ));
YY_BUFFER_STATE yy_scan_bytes YY_PROTO(( yyconst char *bytes, int len ));

static void *yy_flex_alloc YY_PROTO(( yy_size_t ));
static void *yy_flex_realloc YY_PROTO(( void *, yy_size_t ));
static void yy_flex_free YY_PROTO(( void * ));

#define yy_new_buffer yy_create_buffer

#define yy_set_interactive(is_interactive) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_is_interactive = is_interactive; \
	}

#define yy_set_bol(at_bol) \
	{ \
	if ( ! yy_current_buffer ) \
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE ); \
	yy_current_buffer->yy_at_bol = at_bol; \
	}

#define YY_AT_BOL() (yy_current_buffer->yy_at_bol)


#define YY_USES_REJECT

#define yywrap() 1
#define YY_SKIP_YYWRAP
typedef unsigned char YY_CHAR;
FILE *yyin = (FILE *) 0, *yyout = (FILE *) 0;
typedef int yy_state_type;
extern char *yytext;
#define yytext_ptr yytext

static yy_state_type yy_get_previous_state YY_PROTO(( void ));
static yy_state_type yy_try_NUL_trans YY_PROTO(( yy_state_type current_state ));
static int yy_get_next_buffer YY_PROTO(( void ));
static void yy_fatal_error YY_PROTO(( yyconst char msg[] ));

/* Done after the current pattern has been matched and before the
 * corresponding action - sets up yytext.
 */
#define YY_DO_BEFORE_ACTION \
	yytext_ptr = yy_bp; \
	yytext_ptr -= yy_more_len; \
	yyleng = (int) (yy_cp - yytext_ptr); \
	yy_hold_char = *yy_cp; \
	*yy_cp = '\0'; \
	yy_c_buf_p = yy_cp;

#define YY_NUM_RULES 205
#define YY_END_OF_BUFFER 206
static yyconst short int yy_acclist[871] =
    {   0,
    16386,    4,    4,  206,  204,  205,    1,  204,  205,    7,
      205,  193,  204,  205,  204,  205,  194,  204,  205,  194,
      204,  205,  194,  196,  204,  205,  194,  204,  205,  195,
      196,  204,  205,    8,  194,  204,  205,  191,  204,  205,
      190,  204,  205,  192,  204,  205,   77,  204,  205,  171,
      204,  205,  185,  204,  205,  201,  204,  205,  201,  204,
      205,  201,  204,  205,  201,  204,  205,  201,  204,  205,
      201,  204,  205,  201,  204,  205,  201,  204,  205,  201,
      204,  205,  201,  204,  205,  201,  204,  205,  201,  204,
      205,  201,  204,  205,  201,  204,  205,  201,  204,  205,

      201,  204,  205,  201,  204,  205,  201,  204,  205,  201,
      204,  205,  201,  204,  205,  201,  204,  205,  201,  204,
      205,    1,  204,  205,16386,  204,  205,  204,  205, 8194,
      195,  196,  204,  205,  205,    3,  205,    4,  205,    5,
      205,  205,   15,  205,    1,    6,  203,  203,  186,  196,
       10,  196,  195,  196,  188,  187,  189,  202,  201,  201,
      201,  201,  201,   42,  201,  170,  201,  201,  201,  201,
      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
       40,  201,  201,  201,  201,  201,  201,  201,  201,   67,
      201,  201,  201,  201,  201,  201,  201,   61,  201,  201,

      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
      201,  201,   57,  201,  201,   88,  201,  201,  201,  197,
      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
      201,  201,  201,  201,  201,  201,  201,  201,  201,  201,
      201,  201,  201,   41,  201,  201,  201,  201,  201,  201,
      201,  201,  201,  201,  201,  201,    1,16386, 8194,   17,
       18, 8194,  195,  196,    3,    4,   14,  196,   10,  201,
      138,  201,  201,   87,  201,  201,  166,  201,  201,  201,
      201,  201,  201,  201,  105,  201,  201,  201,  201,  201,
      201,  201,  201,  201,  201,  128,  201,  201,  201,  169,

      201,  201,   80,  201,   16,  201,   95,  201,  201,   82,
      201,  156,  201,   90,  201,  201,  201,  201,  201,  132,
      201,  201,  201,   34,  201,  201,  201,  201,  201,  201,
      201,  201,  201,  201,  201,  136,  201,  201,  201,  154,
      201,  120,  201,  201,  201,  133,  201,  201,  201,  201,
      143,  201,  201,  142,  201,  140,  201,  201,  114,  201,
      201,   89,  201,  201,  201,  201,  201,  201,  201,  201,
      201,  141,  201,  201,  201,  201,   12,  201,  201,  201,
      201,  201,  201,  201,  201,  201,  201,  201,  139,  201,
      126,  201,  201,  201,  135,  201,  201,  201,  201,   53,

      201,  201,  201,  130,  201,  201,  201,  201,  201,  201,
      201,  201,  201,  201,  201,  155,  201,  201,  201,  201,
      201,  201,   91,  201,   14,  201,  129,  201,  201,  127,
      201,  131,  201,  119,  201,  118,  201,  168,  202,  125,
      201,  201,  201,   37,  201,  165,  202,  201,  201,  201,
      201,  201,  201,  201,   85,  201,  201,  201,   16,   16,
      201,   63,  201,  201,  201,  201,  201,  201,   83,  201,
      201,  201,  100,  201,  137,  201,  201,  201,  184,  201,
      201,   51,  201,  167,  202,  201,  201,  201,  201,  201,
      201,  201,   96,  201,  201,   39,  201,  201,  201,  146,

      202,  201,   46,  201,  201,   68,  201,  201,  201,  177,
      201,  179,  201,  201,  201,  201,   84,  201,  104,  201,
      201,    9,   11,  201,  201,  201,  201,  201,  201,  201,
      201,  201,   70,  201,  201,  201,  134,  201,  201,   45,
      201,  157,  202,  201,  201,  201,   71,  201,  102,  201,
       62,  201,  201,  201,  201,  199,  201,  201,  201,  201,
      115,  201,   48,  201,  201,  201,  201,   14,  201,  201,
       35,  201,  201,   99,  201,   69,  201,   75,  201,  201,
      201,  201,   97,  201,  175,  202,  201,   16,   16,  201,
      201,   64,  201,   66,  201,   33,  201,  198,  201,  201,

      201,  200,  201,  201,  201,  201,   52,  201,  201,  201,
       78,  201,  152,  201,  201,   60,  201,  144,  202,   55,
      201,  201,  201,  201,  201,  201,  116,  201,  178,  202,
       72,  201,  201,  201,  201,  201,   81,  201,    9,    9,
      201,  201,  201,  201,  201,  201,  201,  201,  201,  117,
      201,  182,  201,  201,  201,  201,  201,  176,  202,  180,
      201,  151,  202,   50,  201,  201,   73,  201,   47,  201,
      201,  201,   14,  201,  201,  201,  107,  201,   98,  201,
       76,  201,  201,  201,  201,  201,   65,  201,   24,   25,
      201,   32,  201,  101,  201,  201,  201,   13,  201,  158,

      202,  201,  147,  202,  149,  202,  161,  201,  201,  159,
      201,  160,  201,  201,   93,  201,  201,  108,  201,  201,
      201,  201,   49,  201,  201,   79,  201,  201,  145,  202,
      153,  201,  150,  202,  201,  172,  201,  183,  202,   56,
      201,  201,   36,  201,  174,  201,  181,  202,  148,  202,
       92,  201,  201,  201,  201,  106,  201,  109,  202,   21,
      201,  201,   38,  201,  201,   23,   19,  201,  111,  202,
      201,  201,  201,  201,  201,   94,  201,  201,   43,  201,
      201,   86,  201,   74,  201,  201,  201,  173,  202,   44,
      201,  121,  201,  201,  110,  202,   59,  201,  201,   20,

      202,  201,  201,  201,  163,  201,  124,  201,  201,  201,
      201,  201,  201,  123,  201,  201,   26,   27,  201,   58,
      201,  201,  201,  124,  201,  112,  201,  103,  201,  201,
      201,  201,  201,   28,   29,  113,  202,  201,  201,  124,
      201,   54,  201,  201,  201,   30,   31,  162,  201,  201,
      201,  201,  201,  201,  201,  201,   16,  201,  164,  201,
      201,  122,  201,  201,  201,  201,  201,  201,   22,  201
    } ;

static yyconst short int yy_accept[654] =
    {   0,
        1,    1,    2,    2,    2,    3,    4,    4,    4,    4,
        4,    5,    7,   10,   12,   15,   17,   20,   23,   27,
       30,   34,   38,   41,   44,   47,   50,   53,   56,   59,
       62,   65,   68,   71,   74,   77,   80,   83,   86,   89,
       92,   95,   98,  101,  104,  107,  110,  113,  116,  119,
      122,  126,  128,  130,  135,  136,  138,  140,  142,  143,
      145,  146,  147,  147,  148,  149,  150,  151,  151,  152,
      153,  155,  156,  157,  158,  159,  159,  160,  161,  162,
      163,  164,  166,  168,  169,  170,  171,  172,  173,  174,
      175,  176,  177,  178,  179,  180,  181,  183,  184,  185,

      186,  187,  188,  189,  190,  192,  193,  194,  195,  196,
      197,  198,  200,  201,  202,  203,  204,  205,  206,  207,
      208,  209,  210,  211,  212,  213,  215,  216,  218,  219,
      220,  222,  223,  224,  225,  226,  227,  228,  229,  230,
      231,  232,  233,  234,  235,  236,  237,  238,  239,  240,
      241,  242,  243,  244,  246,  247,  248,  249,  250,  251,
      252,  253,  254,  255,  256,  257,  259,  260,  260,  261,
      261,  262,  265,  266,  267,  267,  268,  268,  269,  270,
      271,  273,  274,  276,  277,  279,  280,  281,  282,  283,
      284,  285,  287,  288,  289,  290,  291,  292,  293,  294,

      295,  296,  298,  299,  300,  302,  303,  305,  307,  309,
      310,  312,  314,  316,  317,  318,  319,  320,  322,  323,
      324,  326,  327,  328,  329,  330,  331,  332,  333,  334,
      335,  336,  338,  339,  340,  342,  344,  345,  346,  348,
      349,  350,  351,  353,  354,  356,  358,  359,  361,  362,
      364,  365,  366,  367,  368,  369,  370,  371,  372,  374,
      375,  376,  377,  379,  380,  381,  382,  383,  384,  385,
      386,  387,  388,  389,  391,  393,  394,  395,  397,  398,
      399,  400,  402,  403,  404,  406,  407,  408,  409,  410,
      411,  412,  413,  414,  415,  416,  418,  419,  420,  421,

      422,  423,  425,  425,  426,  427,  429,  430,  432,  434,
      436,  438,  440,  442,  443,  444,  446,  448,  449,  450,
      451,  452,  453,  454,  455,  457,  458,  459,  460,  462,
      464,  465,  465,  465,  466,  467,  468,  469,  471,  472,
      473,  475,  477,  478,  479,  481,  482,  484,  486,  487,
      488,  489,  490,  491,  492,  493,  495,  496,  498,  499,
      500,  502,  503,  505,  506,  508,  509,  510,  512,  514,
      515,  516,  517,  519,  521,  522,  523,  524,  525,  526,
      527,  528,  529,  530,  531,  532,  533,  535,  536,  537,
      539,  540,  542,  544,  545,  546,  547,  549,  551,  553,

      554,  555,  556,  558,  559,  560,  561,  563,  565,  566,
      567,  568,  569,  570,  571,  573,  574,  576,  578,  580,
      581,  582,  583,  585,  587,  588,  589,  590,  591,  592,
      594,  594,  594,  594,  594,  594,  594,  596,  598,  600,
      601,  602,  604,  605,  606,  607,  609,  610,  611,  613,
      615,  616,  618,  620,  622,  623,  624,  625,  626,  627,
      629,  631,  633,  634,  635,  636,  637,  639,  640,  641,
      642,  643,  644,  645,  646,  647,  648,  649,  650,  652,
      654,  655,  656,  657,  658,  660,  662,  664,  666,  667,
      669,  671,  672,  673,  674,  675,  676,  677,  679,  681,

      683,  684,  685,  686,  687,  689,  690,  690,  690,  690,
      691,  691,  691,  692,  694,  696,  697,  698,  700,  702,
      703,  705,  707,  709,  710,  712,  714,  715,  717,  718,
      720,  721,  722,  723,  725,  726,  728,  729,  731,  733,
      735,  736,  738,  740,  742,  743,  745,  747,  749,  751,
      753,  754,  755,  756,  758,  760,  762,  763,  765,  766,
      767,  767,  767,  767,  767,  769,  771,  772,  773,  774,
      775,  776,  778,  779,  781,  782,  784,  786,  787,  788,
      790,  792,  794,  795,  797,  799,  800,  800,  800,  800,
      800,  802,  803,  804,  805,  807,  809,  810,  811,  812,

      813,  814,  816,  817,  817,  818,  818,  819,  820,  822,
      823,  824,  824,  824,  826,  828,  830,  831,  832,  833,
      834,  835,  836,  838,  839,  840,  840,  841,  842,  844,
      845,  846,  847,  848,  850,  851,  852,  853,  854,  855,
      856,  857,  859,  861,  862,  864,  865,  866,  867,  868,
      869,  871,  871
    } ;

static yyconst int yy_ec[256] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    2,    3,
        2,    2,    2,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,    4,    5,    6,    7,    1,    1,    8,    9,
       10,   11,   12,   13,   14,   15,   16,   17,   17,   17,
       17,   17,   17,   17,   17,   17,   17,   18,   13,   19,
       20,   21,   22,   23,   26,   27,   28,   29,   30,   31,
       32,   33,   34,   35,   36,   37,   38,   39,   40,   41,
       42,   43,   44,   45,   46,   47,   48,   49,   50,   51,
        1,    1,    1,   24,   25,    1,   26,   27,   28,   29,

       30,   31,   32,   33,   34,   35,   36,   37,   38,   39,
       40,   41,   42,   43,   44,   45,   46,   47,   48,   49,
       50,   51,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,

        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1
    } ;

static yyconst int yy_meta[52] =
    {   0,
        1,    2,    3,    1,    1,    1,    4,    1,    1,    1,
        1,    1,    1,    1,    5,    1,    6,    1,    1,    1,
        1,    1,    1,    1,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7,    7,    7,    7,    7,    7,    7,    7,    7,    7,
        7
    } ;

static yyconst short int yy_base[670] =
    {   0,
        0,   50,  546,  540,  544,  540,  527,  525,    0,    0,
      526, 1907,  522,  507, 1907,   50, 1907,  490,   40,  483,
       44, 1907,   42, 1907,  478, 1907, 1907, 1907,   53,   68,
       57,  107,   39,  124,   50,   86,   71,  112,   91,  112,
      126,  142,  148,  150,  171,  192,   91,  172,  194,   70,
       64,  477,  472,   88, 1907,  457,    0, 1907,  458, 1907,
      457, 1907,   89,   99, 1907, 1907,   98,  190,    0,  107,
      214, 1907, 1907, 1907, 1907,    0,  185,  196,  199,  223,
      208,  226,  235,  238,  240,  241,  242,  251,  255,  256,
      252,  266,  269,  262,  286,  271,  287,  276,  282,  293,

      273,  306,  311,  312,  316,  315,  318,  322,  331,  332,
      333,  327,  344,  347,  348,  350,  354,  371,  353,  349,
      365,  372,  359,  390,  395,  399,  402,  405,  406,  408,
      409,  415,  419,  421,  422,  441,  433,  435,  434,  440,
      461,  474,  477,  456,  447,  488,  489,  487,  490,  493,
      502,  505,  449,  504,  508,  515,  518,  521,  530,  531,
      534,  537,  541,  543,  546,  160,  440,  443, 1907,  441,
     1907,  428,  414,    0,  398,  375,  367,  356,    0,  363,
      555,  557,  559,  561,  568,  571,  575,  577,  578,  584,
      581,  587,  590,  591,  588,  597,  602,  604,  615,  616,

      617,  619,  620,  626,  622,  632,  629,  636,  635,  638,
      659,  639,  656,  662,  668,  663,  669,  672,  673,  674,
      679,  685,  688,  689,  690,  694,  692,  703,  712,  713,
      715,  714,  716,  718,  730,  732,  734,  741,  743,  746,
      747,  750,  759,  761,  763,  764,  765,  766,  768,  775,
      778,  779,  782,  781,  784,  785,  788,  795,  791,  797,
      801,  814,  821,  823,  825,  826,  827,  828,  830,  837,
      840,  843,  844,  847,  849,  853,  860,  862,  869,  871,
      872,  874,  875,  881,  884,  885,  886,  888,  891,  895,
      890,  904,  901,  908,  917,  922,  926,  929,  932,  933,

      935,  936,    0,  335,  328,  938,  939,  942,  945,  948,
      952, 1907,  957,  958,  961,  959, 1907,  963,  968,  972,
      970,  975,  981,  977,  979,  984,  986,  326, 1003,  991,
      997, 1001,  983, 1007, 1014, 1019, 1029, 1032, 1033, 1035,
     1036, 1039, 1045, 1046, 1048, 1057, 1052, 1907, 1062, 1063,
     1066, 1073, 1075, 1078, 1076, 1079, 1080, 1082, 1085, 1089,
     1907, 1091, 1092, 1094, 1095, 1107, 1116, 1117, 1118, 1119,
     1122, 1123, 1128, 1129, 1132,  304, 1907, 1133, 1135, 1138,
     1142, 1145, 1151, 1154, 1161, 1156, 1158, 1165, 1167, 1172,
     1176, 1182, 1907, 1186, 1187, 1192, 1193, 1196, 1198, 1202,

     1209, 1212, 1213, 1214, 1216, 1218, 1223, 1225, 1227, 1228,
     1229,    0, 1232, 1230, 1234, 1239, 1245, 1251, 1255, 1258,
     1265, 1264, 1267, 1907, 1270,    0,  294, 1274, 1277, 1271,
      256,  379,  241,  234,  216,  213, 1276, 1280, 1281, 1283,
     1290, 1299, 1302, 1303, 1304, 1305, 1306, 1308, 1309, 1315,
     1318, 1319, 1907, 1322, 1325, 1329, 1331, 1334, 1335, 1338,
     1907, 1345, 1347, 1348, 1349, 1350, 1352,    0,  241, 1361,
     1364, 1363, 1375, 1378, 1379, 1380, 1389, 1390, 1393, 1394,
     1396, 1403, 1405, 1406, 1907, 1408, 1907, 1410, 1419, 1421,
     1424, 1425, 1426,    0, 1428, 1430, 1435, 1439, 1440, 1441,

     1444, 1445, 1451, 1446, 1456, 1907,  209,  176,  175, 1907,
      159,  155, 1460, 1461, 1462, 1463, 1472, 1474, 1907, 1477,
     1907, 1907, 1479, 1486, 1488, 1490, 1491, 1492, 1493, 1497,
     1503, 1506, 1507, 1504, 1513, 1509, 1520, 1907, 1522, 1907,
     1525, 1527, 1907, 1534, 1537, 1538, 1539, 1907, 1907, 1541,
     1544, 1550, 1551, 1553, 1907, 1554, 1555, 1556, 1560, 1907,
      141,  134,  120,  122, 1557, 1907, 1566, 1571, 1572, 1577,
     1576, 1582, 1583, 1586, 1588, 1592, 1593, 1603, 1604, 1907,
     1608, 1609, 1614, 1907, 1615, 1619,  120,  115,  111,   79,
     1907, 1620, 1625, 1626, 1635, 1645, 1636, 1642, 1646, 1641,

     1648, 1651, 1658,   75, 1907,   66, 1907, 1661, 1670, 1671,
     1675,  166, 1681, 1686, 1677, 1687, 1689, 1690, 1692, 1693,
       82,   81, 1907, 1702, 1703, 1711, 1907, 1708, 1707, 1709,
     1718, 1907, 1907, 1719, 1724, 1733, 1735, 1737, 1738, 1740,
     1749, 1755, 1753, 1754, 1756, 1758, 1765, 1759, 1771, 1782,
     1776, 1907, 1817, 1824, 1831, 1838, 1842, 1849, 1856, 1863,
     1869, 1876,   64, 1879, 1883,   47, 1890, 1897, 1899
    } ;

static yyconst short int yy_def[670] =
    {   0,
      652,    1,  653,  653,  654,  654,  653,  653,  655,  655,
      652,  652,  652,  652,  652,  656,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  657,  657,
      657,  657,   31,   31,   31,   31,  657,  657,   31,   31,
       31,  657,   31,   39,   44,   31,  657,  657,   31,  657,
      652,  658,  659,  652,  652,  652,  660,  652,  661,  652,
      652,  652,  656,  656,  652,  652,  652,  652,  662,  652,
      652,  652,  652,  652,  652,  663,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,

      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  114,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  652,  652,  658,  652,  659,
      652,  652,  652,  660,  661,  664,  652,  652,  662,  665,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,

      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,

      657,  657,  666,  664,  665,  657,  657,  657,  657,  657,
      657,  652,  657,  657,  657,  657,  652,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  667,  657,  657,
      657,  652,  652,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  652,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      652,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  668,  652,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  652,  657,  657,  657,  657,  657,  657,  657,

      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  669,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  652,  657,  667,  667,  657,  657,  657,
      652,  652,  652,  652,  652,  652,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  652,  657,  657,  657,  657,  657,  657,  657,
      652,  657,  657,  657,  657,  657,  657,  668,  668,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  652,  657,  652,  657,  657,  657,
      657,  657,  657,  669,  657,  657,  657,  657,  657,  657,

      657,  657,  657,  657,  657,  652,  652,  652,  652,  652,
      652,  652,  657,  657,  657,  657,  657,  657,  652,  657,
      652,  652,  657,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  652,  657,  652,
      657,  657,  652,  657,  657,  657,  657,  652,  652,  657,
      657,  657,  657,  657,  652,  657,  657,  657,  657,  652,
      652,  652,  652,  652,  657,  652,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  652,
      657,  657,  657,  652,  657,  657,  652,  652,  652,  652,
      652,  657,  657,  657,  657,  657,  657,  657,  657,  657,

      657,  657,  657,  652,  652,  652,  652,  657,  657,  657,
      657,  652,  652,  657,  657,  657,  657,  657,  657,  657,
      652,  652,  652,  657,  657,  652,  652,  657,  657,  657,
      657,  652,  652,  657,  657,  657,  657,  657,  657,  657,
      657,  657,  657,  657,  657,  657,  657,  657,  657,  657,
      657,    0,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652
    } ;

static yyconst short int yy_nxt[1959] =
    {   0,
       12,   13,   14,   15,   16,   12,   12,   12,   17,   17,
       18,   17,   17,   17,   19,   20,   21,   22,   23,   24,
       25,   26,   27,   28,   29,   30,   31,   32,   33,   34,
       35,   36,   37,   38,   29,   29,   39,   40,   41,   42,
       43,   29,   44,   45,   46,   47,   48,   49,   50,   29,
       29,   51,   64,  412,   65,   52,   67,   53,   70,   75,
       71,   72,   73,   75,   94,  166,   54,   76,   95,   68,
      180,   76,   96,   68,   75,  104,   75,   75,   97,   77,
      167,   77,   76,  105,   76,   76,   84,  633,  632,  106,
       85,   64,  107,   65,   78,   79,   86,   75,  622,   87,

      111,   64,   70,   65,  172,   76,   80,  621,  607,  165,
       81,   82,   83,   75,   67,  108,  115,   68,   75,   77,
      116,   76,  109,   67,  117,  110,   76,   68,   77,  156,
      118,  157,   88,   77,  158,  119,   68,  120,  606,   89,
       90,   77,  112,   91,  605,  121,   92,  604,   75,  113,
      114,  122,   93,   77,   77,  123,   76,   77,  590,   77,
       98,  166,   99,  100,  589,  124,  101,  612,   77,  102,
      588,  125,  103,  129,  613,  135,  167,  130,   75,  136,
      126,  131,  127,  137,  128,  587,   76,  132,  564,   77,
      133,   75,  563,  134,  138,  139,   77,  159,  140,   76,

      141,  177,   75,  177,  142,   75,  178,  143,  562,  561,
       76,  144,  145,   76,   75,  146,  147,  150,  148,  160,
      149,  151,   76,  161,  152,  153,  162,  163,   70,   75,
       71,  154,   75,   77,  155,  560,  164,   76,  182,  181,
       76,   75,  469,   68,   75,  512,   75,   75,   75,   76,
      184,  183,   76,  185,   76,   76,   76,   75,   75,  186,
      187,   75,   75,  511,  510,   76,   76,  188,   75,   76,
       76,  193,   75,  509,  189,   75,   76,   75,  190,   75,
       76,  197,   75,   76,  191,   76,  506,   76,   75,  192,
       76,  198,   75,   75,  194,  427,   76,  195,  196,   75,

       76,   76,  199,  200,  201,  469,  204,   76,  207,  202,
      211,  203,   75,  205,  208,  214,  206,   75,   75,  210,
       76,   75,   75,  212,   75,   76,   76,  427,   75,   76,
       76,  209,   76,   75,   75,  213,   76,   75,   75,   75,
      216,   76,  215,  222,  217,   76,   76,   76,  219,  303,
       75,  218,  220,   75,   75,   75,   75,  221,   76,   75,
       75,   76,   76,   76,   76,   75,  223,   76,   76,   75,
      224,   75,  178,   76,  233,  225,  226,   75,   75,   76,
      234,  227,  229,  178,  228,   76,   76,  230,  235,  303,
      231,  232,  237,  244,  236,  242,   75,  243,  238,  175,

      246,   75,  239,  245,   76,   75,  248,  249,   75,   76,
      240,   75,   75,   76,   75,   75,   76,  247,  241,   76,
       76,   75,   76,   76,  507,   75,  508,   75,   75,   76,
      173,  252,  251,   76,  250,   76,   76,  255,  253,   75,
       75,   75,   70,  171,  172,  169,   75,   76,   76,   76,
      256,  254,  257,   75,   76,   75,  167,   68,   61,  175,
      259,   76,   75,   76,  268,  258,  260,   75,  261,  262,
       76,  269,  271,  173,  171,   76,   77,  270,  263,  169,
       75,  264,  272,   75,  265,  266,  289,  267,   76,  278,
      273,   76,  277,   75,   75,   75,   75,   74,   69,   75,

       66,   76,   76,   76,   76,  274,  276,   76,   75,   62,
       75,   75,  275,  279,   75,  282,   76,  280,   76,   76,
      283,   75,   76,   61,   75,  652,   59,   75,   59,   76,
      281,  285,   76,  284,  288,   76,   75,   75,  286,  290,
       75,  291,   58,   75,   76,   76,   58,   75,   76,   75,
      287,   76,   75,  292,  295,   76,   56,   76,  294,  293,
       76,   75,   56,   75,  297,   75,  296,   75,  652,   76,
      299,   76,  298,   76,   75,   76,  301,   75,  652,  300,
      652,   75,   76,   75,   75,   76,  307,   75,  302,   76,
      312,   76,   76,   75,  317,   76,   75,   75,   76,  652,

      306,   76,   76,   75,   76,   76,  652,  314,   75,  308,
       75,   76,  313,  309,  311,  315,   76,  310,   76,  652,
      316,   75,   75,   75,  318,   75,   75,  319,   75,   76,
       76,   76,   75,   76,   76,   75,   76,  328,   75,  652,
       76,   75,   75,   76,   75,   75,   76,  320,  652,   76,
       76,  325,   76,   76,  321,  326,  322,  327,  652,  652,
      332,  323,   75,  652,  652,   75,  324,  330,   75,   75,
       76,  331,  333,   76,   75,   75,   76,   76,   75,   75,
       75,  329,   76,   76,  652,   75,   76,   76,   76,  652,
      337,   75,  334,   76,   75,   75,   75,  336,  348,   76,

       75,  335,   76,   76,   76,  652,   76,  652,   76,   75,
      341,  339,  342,  338,  343,  345,  340,   76,   75,   75,
       75,   75,   75,  652,   75,  652,   76,   76,   76,   76,
       76,  344,   76,  347,  652,  346,   75,  652,   75,  652,
       75,  350,  349,  353,   76,  354,   76,   75,   76,   75,
      652,  652,   75,   75,  652,   76,   75,   76,  351,  352,
       76,   76,  355,  356,   76,   75,  357,  361,  652,   75,
       75,   75,   75,   76,   75,   76,  359,   76,   76,   76,
       76,   75,   76,  360,   75,   75,  358,   75,   75,   76,
       75,   75,   76,   76,   75,   76,   76,   75,   76,   76,

      652,   75,   76,   75,  652,   76,  652,   75,  362,   76,
      652,   76,  363,  366,  369,   76,  652,  365,  364,  368,
       75,  371,  376,  377,  367,  373,  370,   75,   76,   75,
      652,   75,   75,   75,   75,   76,   75,   76,  372,   76,
       76,   76,   76,   75,   76,  374,   75,  375,  652,   75,
       75,   76,  378,   75,   76,   75,  381,   76,   76,   75,
      382,   76,  652,   76,  652,  652,   75,   76,   75,  379,
      384,  380,  386,  383,   76,   75,   76,   75,  393,  387,
       75,   75,  388,   76,  385,   76,   76,   75,   76,   76,
       75,   75,   75,  389,   75,   76,   75,   75,   76,   76,

       76,   75,   76,  652,   76,   76,  390,   75,  652,   76,
       75,  392,  652,  391,   75,   76,  394,  652,   76,  395,
      400,  397,   76,   75,  401,  396,  399,  402,   75,  652,
      398,   76,   75,  403,  404,   75,   76,  405,   75,   75,
       76,   75,   75,   76,   75,   75,   76,   76,   75,   76,
       76,   75,   76,   76,   75,  406,   76,  408,   75,   76,
      652,  410,   76,   75,   75,   75,   76,   75,  409,   75,
      407,   76,   76,   76,   75,   76,   75,   76,   75,  411,
      652,   75,   76,   75,   76,   75,   76,   75,  413,   76,
      424,   76,   75,   76,  414,   76,  415,   75,   76,  416,

       76,  418,  332,   75,  328,   76,  423,  652,  421,   75,
      417,   76,  419,   75,  422,  420,  434,   76,  652,  652,
       75,   76,  652,  652,  429,   75,  435,  430,   76,  652,
      436,  425,  652,   76,  431,   75,  652,  437,   75,   75,
      428,   75,   75,   76,  432,   75,   76,   76,  433,   76,
       76,   75,   75,   76,   75,  652,  438,  652,   75,   76,
       76,  439,   76,   75,  442,  443,   76,  652,   75,   75,
      652,   76,   75,  445,  440,  441,   76,   76,  444,   75,
       76,   75,  453,  446,   75,   75,   75,   76,   75,   76,
       76,   75,   76,   76,   76,   75,   76,   75,   75,   76,

       75,   75,  652,   76,  447,   76,   76,  652,   76,   76,
      449,  652,  448,   75,  452,  450,  454,  451,  652,  458,
      457,   76,   75,  461,   75,   75,  456,  455,   75,   75,
       76,   76,   76,   76,   75,   75,   76,   76,   75,   75,
      459,   75,   76,   76,   75,  460,   76,   76,   75,   76,
      464,   75,   76,  652,  466,  463,   76,   75,  470,   76,
       75,  465,   75,  462,   75,   76,  652,   75,   76,  467,
       76,   75,   76,   75,  471,   76,  652,  652,   75,   76,
      472,   76,   75,  652,  473,  478,   76,  652,   75,  474,
       76,  476,   75,   75,  477,  475,   76,  652,   75,   75,

       76,   76,   75,  652,   75,  479,   76,   76,  485,  481,
       76,  480,   76,  652,  483,   75,   76,  652,  487,   75,
       75,  484,   75,   76,   75,  482,   76,   76,   76,   75,
       76,   75,   76,   75,   75,   75,   75,   76,   75,   76,
       75,   76,   76,   76,   76,   75,   76,  486,   76,  490,
      488,   75,  652,   76,  652,  652,  491,   75,  489,   76,
      495,   75,  493,  497,   75,   76,  652,  492,  499,   76,
       75,   75,   76,   75,  498,  496,   75,   75,   76,   76,
       75,   76,   75,   75,   76,   76,   75,   75,   76,   75,
       76,   76,  652,  652,   76,   76,   75,   76,  652,  652,

      500,  501,  502,  504,   76,   75,  503,  505,   75,   75,
       75,   75,   75,   76,  519,   75,   76,   76,   76,   76,
       76,   75,   76,   76,   75,   75,  652,  513,   75,   76,
      515,  521,   76,   76,  514,  522,   76,   75,  652,   76,
       75,   75,  652,   76,   75,   76,  517,  516,   76,   76,
      518,   75,   76,   75,   75,   75,   75,  523,   75,   76,
      520,   76,   76,   76,   76,  652,   76,   75,  524,   75,
       75,  652,  652,  528,  529,   76,  527,   76,   76,  525,
      526,   75,  652,  652,  538,   75,  540,  532,  533,   76,
      531,  530,   76,   76,   76,   75,   75,  652,  652,   75,

      543,  536,   75,   76,   76,  534,  535,   76,   76,   75,
       76,   75,   75,  652,  548,  652,   75,   76,  537,   76,
       76,  539,   76,  544,   76,  549,  541,   75,  542,  652,
       75,   75,   75,   76,   75,   76,   75,  546,   76,   76,
       76,   75,   76,  547,   76,  555,   75,   75,  545,   76,
       75,   75,   75,   76,   76,   76,  652,   75,   76,   76,
       76,  552,   75,  553,  551,   76,   75,   75,   75,  566,
       76,  652,  550,  556,   76,   76,   76,   76,   75,  554,
       75,  652,  652,   75,  559,   75,   76,  652,   76,  565,
      557,   76,   75,   76,   75,  558,   75,   75,   75,   75,

       76,  567,   76,   75,   76,   76,   76,   76,  652,   75,
       75,   76,   75,   75,  652,   75,  571,   76,   76,   75,
       76,   76,  568,   76,  569,  570,   75,   76,   75,  652,
      652,   75,  573,   75,   76,  572,   76,  574,  575,   76,
       75,   76,  576,   75,   75,  580,  652,   75,   76,  577,
       75,   76,   76,   76,  578,   76,   75,   75,   76,  584,
       75,   75,   75,  591,   76,   76,   75,   76,   76,   76,
       76,   76,   75,  652,   76,  581,  652,   75,   75,  652,
       76,  579,   75,   75,  585,   76,   76,  582,   75,   75,
       76,   76,   75,  652,   75,  592,   76,   76,   75,   75,

       76,  583,   76,  652,  586,  595,   76,   76,  652,   75,
       75,  593,  597,  596,   75,   75,  594,   76,   76,  652,
       75,   75,   76,   76,  598,   75,   75,  599,   76,   76,
      652,   75,   75,   76,   76,  652,  652,  600,  601,   76,
       76,   75,   75,  602,  603,  652,  612,   75,   75,   76,
       76,   75,   75,  613,   75,   76,   76,   75,  608,   76,
       76,  652,   76,  652,   75,   76,  652,  623,  611,  609,
      610,  616,   76,  617,  615,   76,   75,   75,  652,  618,
      652,   75,  626,   75,   76,   76,  619,  612,  614,   76,
      627,   76,   75,   75,  613,   75,   75,  652,   75,   75,

       76,   76,  620,   76,   76,  625,   76,   76,   75,   75,
      624,  652,  626,   75,   75,   75,   76,   76,  652,  629,
      627,   76,   76,   76,   75,   75,  631,  652,  652,  652,
       75,  628,   76,   76,  652,  630,  635,  636,   76,   75,
      634,   75,  637,   75,   75,  652,   75,   76,  652,   76,
      652,   76,   76,  639,   76,   75,  328,  638,  640,   75,
       75,   75,   75,   76,   75,   75,  652,   76,   76,   76,
       76,   75,   76,   76,  641,  642,  652,   75,  652,   76,
      643,  652,   75,  646,  644,   76,  647,  645,   75,  648,
       76,  652,  652,  652,  652,  652,   76,  652,  652,  652,

      652,  652,  649,  652,  652,  652,  652,  652,  651,  652,
      652,  652,  652,  652,  652,  652,  650,   55,   55,   55,
       55,   55,   55,   55,   57,   57,   57,   57,   57,   57,
       57,   60,   60,   60,   60,   60,   60,   60,   63,   63,
       63,   63,   63,   63,   63,   77,   77,   77,   77,  168,
      168,  168,  168,  168,  168,  168,  170,  170,  170,  170,
      170,  170,  170,  174,  174,  652,  174,  174,  174,  174,
      176,  652,  652,  652,  652,  176,  179,  179,  652,  179,
      179,  179,  179,  304,  304,  304,  305,  652,  305,  305,
      426,  426,  652,  426,  426,  426,  426,  468,  468,  652,

      468,  468,  468,  468,  494,  494,   11,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652
    } ;

static yyconst short int yy_chk[1959] =
    {   0,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
        1,    2,   16,  666,   16,    2,   19,    2,   21,   29,
       21,   23,   23,   31,   33,   51,    2,   29,   33,   19,
      663,   31,   33,   21,   30,   35,   50,   37,   33,   35,
       51,   33,   30,   35,   50,   37,   31,  622,  621,   35,
       31,   63,   35,   63,   30,   30,   31,   47,  606,   31,

       37,   64,   54,   64,   54,   47,   30,  604,  590,   50,
       30,   30,   30,   32,   67,   36,   39,   54,   38,   36,
       39,   32,   36,   70,   39,   36,   38,   67,   36,   47,
       39,   47,   32,   39,   47,   39,   70,   40,  589,   32,
       32,   40,   38,   32,  588,   40,   32,  587,   42,   38,
       38,   40,   32,   34,   40,   41,   42,   34,  564,   41,
       34,  166,   34,   34,  563,   41,   34,  612,   41,   34,
      562,   41,   34,   43,  612,   44,  166,   43,   48,   44,
       42,   43,   42,   44,   42,  561,   48,   43,  512,   44,
       43,   77,  511,   43,   44,   44,   45,   48,   45,   77,

       45,   68,   78,   68,   45,   79,   68,   45,  509,  508,
       78,   45,   45,   79,   81,   45,   45,   46,   45,   49,
       45,   46,   81,   49,   46,   46,   49,   49,   71,   80,
       71,   46,   82,   49,   46,  507,   49,   80,   79,   78,
       82,   83,  469,   71,   84,  436,   85,   86,   87,   83,
       81,   80,   84,   82,   85,   86,   87,   88,   91,   82,
       83,   89,   90,  435,  434,   88,   91,   84,   94,   89,
       90,   87,   92,  433,   84,   93,   94,   96,   85,  101,
       92,   91,   98,   93,   85,   96,  431,  101,   99,   86,
       98,   91,   95,   97,   88,  427,   99,   89,   90,  100,

       95,   97,   92,   92,   92,  376,   94,  100,   96,   92,
       99,   93,  102,   95,   97,  101,   95,  103,  104,   98,
      102,  106,  105,  100,  107,  103,  104,  328,  108,  106,
      105,   97,  107,  112,  305,  100,  108,  109,  110,  111,
      103,  112,  102,  107,  103,  109,  110,  111,  104,  304,
      113,  103,  105,  114,  115,  120,  116,  106,  113,  119,
      117,  114,  115,  120,  116,  123,  108,  119,  117,  180,
      109,  121,  178,  123,  115,  110,  110,  118,  122,  121,
      116,  111,  114,  177,  113,  118,  122,  114,  116,  176,
      114,  114,  117,  121,  116,  119,  124,  120,  118,  175,

      122,  125,  118,  121,  124,  126,  123,  123,  127,  125,
      118,  128,  129,  126,  130,  131,  127,  122,  118,  128,
      129,  132,  130,  131,  432,  133,  432,  134,  135,  132,
      173,  127,  125,  133,  124,  134,  135,  130,  128,  137,
      139,  138,  172,  170,  172,  168,  140,  137,  139,  138,
      132,  129,  133,  145,  140,  153,  167,  172,   61,   59,
      135,  145,  144,  153,  137,  134,  136,  141,  136,  136,
      144,  137,  139,   56,   53,  141,  136,  138,  136,   52,
      142,  136,  140,  143,  136,  136,  153,  136,  142,  145,
      141,  143,  144,  148,  146,  147,  149,   25,   20,  150,

       18,  148,  146,  147,  149,  142,  143,  150,  151,   14,
      154,  152,  142,  146,  155,  147,  151,  146,  154,  152,
      148,  156,  155,   13,  157,   11,    8,  158,    7,  156,
      146,  150,  157,  149,  152,  158,  159,  160,  151,  154,
      161,  155,    6,  162,  159,  160,    5,  163,  161,  164,
      151,  162,  165,  155,  158,  163,    4,  164,  157,  156,
      165,  181,    3,  182,  160,  183,  159,  184,    0,  181,
      162,  182,  161,  183,  185,  184,  164,  186,    0,  163,
        0,  187,  185,  188,  189,  186,  184,  191,  165,  187,
      190,  188,  189,  192,  195,  191,  193,  194,  190,    0,

      182,  192,  195,  196,  193,  194,    0,  191,  197,  186,
      198,  196,  190,  187,  189,  193,  197,  188,  198,    0,
      194,  199,  200,  201,  196,  202,  203,  197,  205,  199,
      200,  201,  204,  202,  203,  207,  205,  208,  206,    0,
      204,  209,  208,  207,  210,  212,  206,  198,    0,  209,
      208,  204,  210,  212,  199,  204,  200,  206,    0,    0,
      211,  201,  213,    0,    0,  211,  203,  210,  214,  216,
      213,  210,  211,  211,  215,  217,  214,  216,  218,  219,
      220,  208,  215,  217,    0,  221,  218,  219,  220,    0,
      216,  222,  211,  221,  223,  224,  225,  215,  227,  222,

      226,  214,  223,  224,  225,    0,  227,    0,  226,  228,
      220,  218,  222,  217,  223,  224,  219,  228,  229,  230,
      232,  231,  233,    0,  234,    0,  229,  230,  232,  231,
      233,  223,  234,  226,    0,  225,  235,    0,  236,    0,
      237,  229,  228,  232,  235,  233,  236,  238,  237,  239,
        0,    0,  240,  241,    0,  238,  242,  239,  230,  231,
      240,  241,  234,  237,  242,  243,  238,  244,    0,  245,
      246,  247,  248,  243,  249,  244,  241,  245,  246,  247,
      248,  250,  249,  242,  251,  252,  240,  254,  253,  250,
      255,  256,  251,  252,  257,  254,  253,  259,  255,  256,

        0,  258,  257,  260,    0,  259,    0,  261,  247,  258,
        0,  260,  249,  253,  256,  261,    0,  252,  251,  255,
      262,  258,  263,  263,  254,  260,  257,  263,  262,  264,
        0,  265,  266,  267,  268,  263,  269,  264,  258,  265,
      266,  267,  268,  270,  269,  261,  271,  262,    0,  272,
      273,  270,  264,  274,  271,  275,  267,  272,  273,  276,
      268,  274,    0,  275,    0,    0,  277,  276,  278,  265,
      270,  266,  272,  269,  277,  279,  278,  280,  281,  273,
      282,  283,  276,  279,  271,  280,  281,  284,  282,  283,
      285,  286,  287,  277,  288,  284,  291,  289,  285,  286,

      287,  290,  288,    0,  291,  289,  278,  293,    0,  290,
      292,  280,    0,  279,  294,  293,  282,    0,  292,  283,
      289,  286,  294,  295,  290,  284,  288,  291,  296,    0,
      287,  295,  297,  292,  293,  298,  296,  294,  299,  300,
      297,  301,  302,  298,  306,  307,  299,  300,  308,  301,
      302,  309,  306,  307,  310,  295,  308,  298,  311,  309,
        0,  300,  310,  313,  314,  316,  311,  315,  299,  318,
      297,  313,  314,  316,  319,  315,  321,  318,  320,  301,
        0,  322,  319,  324,  321,  325,  320,  323,  307,  322,
      326,  324,  327,  325,  314,  323,  315,  330,  326,  318,

      327,  320,  332,  331,  329,  330,  324,    0,  322,  329,
      319,  331,  321,  334,  323,  321,  333,  329,    0,    0,
      335,  334,    0,    0,  330,  336,  333,  331,  335,    0,
      333,  327,    0,  336,  332,  337,    0,  334,  338,  339,
      329,  340,  341,  337,  332,  342,  338,  339,  332,  340,
      341,  343,  344,  342,  345,    0,  335,    0,  347,  343,
      344,  336,  345,  346,  340,  341,  347,    0,  349,  350,
        0,  346,  351,  344,  337,  339,  349,  350,  343,  352,
      351,  353,  355,  346,  354,  356,  357,  352,  358,  353,
      355,  359,  354,  356,  357,  360,  358,  362,  363,  359,

      364,  365,    0,  360,  349,  362,  363,    0,  364,  365,
      351,    0,  350,  366,  354,  352,  357,  353,    0,  364,
      362,  366,  367,  368,  369,  370,  360,  359,  371,  372,
      367,  368,  369,  370,  373,  374,  371,  372,  375,  378,
      366,  379,  373,  374,  380,  367,  375,  378,  381,  379,
      372,  382,  380,    0,  374,  371,  381,  383,  378,  382,
      384,  373,  386,  370,  387,  383,    0,  385,  384,  375,
      386,  388,  387,  389,  379,  385,    0,    0,  390,  388,
      380,  389,  391,    0,  381,  386,  390,    0,  392,  382,
      391,  384,  394,  395,  385,  383,  392,    0,  396,  397,

      394,  395,  398,    0,  399,  388,  396,  397,  400,  391,
      398,  389,  399,    0,  395,  401,  400,    0,  402,  403,
      404,  396,  405,  401,  406,  394,  402,  403,  404,  407,
      405,  408,  406,  409,  410,  411,  414,  407,  413,  408,
      415,  409,  410,  411,  414,  416,  413,  401,  415,  406,
      404,  417,    0,  416,    0,    0,  409,  418,  405,  417,
      413,  419,  411,  414,  420,  418,    0,  410,  416,  419,
      422,  421,  420,  423,  414,  413,  425,  430,  422,  421,
      428,  423,  437,  429,  425,  430,  438,  439,  428,  440,
      437,  429,    0,    0,  438,  439,  441,  440,    0,    0,

      420,  421,  422,  428,  441,  442,  425,  429,  443,  444,
      445,  446,  447,  442,  448,  449,  443,  444,  445,  446,
      447,  450,  448,  449,  451,  452,    0,  440,  454,  450,
      443,  455,  451,  452,  441,  456,  454,  457,    0,  455,
      458,  459,    0,  456,  460,  457,  445,  444,  458,  459,
      447,  462,  460,  463,  464,  465,  466,  457,  467,  462,
      451,  463,  464,  465,  466,    0,  467,  470,  457,  472,
      471,    0,    0,  459,  462,  470,  458,  472,  471,  457,
      457,  473,    0,    0,  474,  475,  476,  465,  466,  473,
      464,  463,  474,  475,  476,  477,  478,    0,    0,  479,

      480,  472,  481,  477,  478,  470,  471,  479,  480,  482,
      481,  483,  484,    0,  486,    0,  488,  482,  473,  483,
      484,  475,  486,  481,  488,  489,  477,  490,  478,    0,
      491,  492,  493,  489,  495,  490,  496,  483,  491,  492,
      493,  497,  495,  484,  496,  498,  499,  500,  482,  497,
      501,  502,  504,  498,  499,  500,    0,  503,  501,  502,
      504,  495,  505,  496,  493,  503,  513,  514,  515,  516,
      505,    0,  492,  501,  513,  514,  515,  516,  517,  497,
      518,    0,    0,  520,  504,  523,  517,    0,  518,  513,
      502,  520,  524,  523,  525,  503,  526,  527,  528,  529,

      524,  517,  525,  530,  526,  527,  528,  529,    0,  531,
      534,  530,  532,  533,    0,  536,  527,  531,  534,  535,
      532,  533,  520,  536,  523,  524,  537,  535,  539,    0,
        0,  541,  531,  542,  537,  529,  539,  532,  533,  541,
      544,  542,  535,  545,  546,  547,    0,  550,  544,  537,
      551,  545,  546,  547,  541,  550,  552,  553,  551,  554,
      556,  557,  558,  565,  552,  553,  559,  554,  556,  557,
      558,  565,  567,    0,  559,  551,    0,  568,  569,    0,
      567,  545,  571,  570,  557,  568,  569,  552,  572,  573,
      571,  570,  574,    0,  575,  567,  572,  573,  576,  577,

      574,  553,  575,    0,  559,  570,  576,  577,    0,  578,
      579,  568,  573,  571,  581,  582,  569,  578,  579,    0,
      583,  585,  581,  582,  575,  586,  592,  578,  583,  585,
        0,  593,  594,  586,  592,    0,    0,  579,  582,  593,
      594,  595,  597,  583,  586,    0,  596,  600,  598,  595,
      597,  596,  599,  596,  601,  600,  598,  602,  592,  596,
      599,    0,  601,    0,  603,  602,    0,  608,  595,  593,
      594,  598,  603,  599,  597,  608,  609,  610,    0,  600,
        0,  611,  613,  615,  609,  610,  601,  614,  596,  611,
      613,  615,  614,  616,  614,  617,  618,    0,  619,  620,

      614,  616,  603,  617,  618,  611,  619,  620,  624,  625,
      610,    0,  626,  629,  628,  630,  624,  625,    0,  618,
      626,  629,  628,  630,  631,  634,  620,    0,    0,    0,
      635,  617,  631,  634,    0,  619,  625,  628,  635,  636,
      624,  637,  630,  638,  639,    0,  640,  636,    0,  637,
        0,  638,  639,  635,  640,  641,  642,  631,  636,  643,
      644,  642,  645,  641,  646,  648,    0,  643,  644,  642,
      645,  647,  646,  648,  637,  638,    0,  649,    0,  647,
      639,    0,  651,  644,  640,  649,  646,  641,  650,  647,
      651,    0,    0,    0,    0,    0,  650,    0,    0,    0,

        0,    0,  648,    0,    0,    0,    0,    0,  650,    0,
        0,    0,    0,    0,    0,    0,  649,  653,  653,  653,
      653,  653,  653,  653,  654,  654,  654,  654,  654,  654,
      654,  655,  655,  655,  655,  655,  655,  655,  656,  656,
      656,  656,  656,  656,  656,  657,  657,  657,  657,  658,
      658,  658,  658,  658,  658,  658,  659,  659,  659,  659,
      659,  659,  659,  660,  660,    0,  660,  660,  660,  660,
      661,    0,    0,    0,    0,  661,  662,  662,    0,  662,
      662,  662,  662,  664,  664,  664,  665,    0,  665,  665,
      667,  667,    0,  667,  667,  667,  667,  668,  668,    0,

      668,  668,  668,  668,  669,  669,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652,  652,  652,
      652,  652,  652,  652,  652,  652,  652,  652
    } ;

static yy_state_type yy_state_buf[YY_BUF_SIZE + 2], *yy_state_ptr;
static char *yy_full_match;
static int yy_lp;
static int yy_looking_for_trail_begin = 0;
static int yy_full_lp;
static int *yy_full_state;
#define YY_TRAILING_MASK 0x2000
#define YY_TRAILING_HEAD_MASK 0x4000
#define REJECT \
{ \
*yy_cp = yy_hold_char; /* undo effects of setting up yytext */ \
yy_cp = yy_full_match; /* restore poss. backed-over text */ \
yy_lp = yy_full_lp; /* restore orig. accepting pos. */ \
yy_state_ptr = yy_full_state; /* restore orig. state */ \
yy_current_state = *yy_state_ptr; /* restore curr. state */ \
++yy_lp; \
goto find_rule; \
}
static int yy_more_flag = 0;
static int yy_more_len = 0;
#define yymore() (yy_more_flag = 1)
#define YY_MORE_ADJ yy_more_len
#define YY_RESTORE_YY_MORE_OFFSET
char *yytext;
#define INITIAL 0
/*

    YABASIC ---  a simple Basic Interpreter
    written by Marc-Oliver Ihm 1995-2004
    homepage: www.yabasic.de

    FLEX part
     
    This file is part of yabasic and may be copied only 
    under the terms of either the Artistic License or 
    the GNU General Public License (GPL), both of which 
    can be found at www.yabasic.de

*/

#include <string.h>
#undef WINDOWS

#include "bison.h"       /* get tokens from BISON */
#ifndef YABASIC_INCLUDED
#include "yabasic.h"     /* definitions of yabasic */
#endif
extern int main_lineno; /* defined in yabasic.bison: line number of main file */
extern int yylineno; /* defined in yabasic.bison: line number of main file */
int import_lib(char *); /* import library */

#define MAX_INCLUDE_DEPTH 5
#define MAX_INCLUDE_NUMBER 100
static YY_BUFFER_STATE include_stack[MAX_INCLUDE_DEPTH]; /* stack for included libraries */
int include_stack_ptr; /* current position in libfile_stack */
struct libfile_name *libfile_stack[MAX_INCLUDE_DEPTH]; /* stack for library file names */
int libfile_chain_length=0; /* length of libfile_chain */
struct libfile_name *libfile_chain[MAX_INCLUDE_NUMBER]; /* list of all library file names */
struct libfile_name *currlib; /* current libfile as relevant to bison */
int inlib; /* true, while in library */
int fi_pending=0; /* true, if within a short if */
int flex_line=0; /* line number counted in flex */
#define PRELNO 1

#define PASTLNO 2

#define IMPORT 3

#define IMPORT_DONE 4


/* Macros after this point can all be overridden by user definitions in
 * section 1.
 */

#ifndef YY_SKIP_YYWRAP
#ifdef __cplusplus
extern "C" int yywrap YY_PROTO(( void ));
#else
extern int yywrap YY_PROTO(( void ));
#endif
#endif

#ifndef YY_NO_UNPUT
static void yyunput YY_PROTO(( int c, char *buf_ptr ));
#endif

#ifndef yytext_ptr
static void yy_flex_strncpy YY_PROTO(( char *, yyconst char *, int ));
#endif

#ifdef YY_NEED_STRLEN
static int yy_flex_strlen YY_PROTO(( yyconst char * ));
#endif

#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput YY_PROTO(( void ));
#else
static int input YY_PROTO(( void ));
#endif
#endif

#if YY_STACK_USED
static int yy_start_stack_ptr = 0;
static int yy_start_stack_depth = 0;
static int *yy_start_stack = 0;
#ifndef YY_NO_PUSH_STATE
static void yy_push_state YY_PROTO(( int new_state ));
#endif
#ifndef YY_NO_POP_STATE
static void yy_pop_state YY_PROTO(( void ));
#endif
#ifndef YY_NO_TOP_STATE
static int yy_top_state YY_PROTO(( void ));
#endif

#else
#define YY_NO_PUSH_STATE 1
#define YY_NO_POP_STATE 1
#define YY_NO_TOP_STATE 1
#endif

#ifdef YY_MALLOC_DECL
YY_MALLOC_DECL
#else
#if __STDC__
#ifndef __cplusplus
#include <stdlib.h>
#endif
#else
/* Just try to get by without declaring the routines.  This will fail
 * miserably on non-ANSI systems for which sizeof(size_t) != sizeof(int)
 * or sizeof(void*) != sizeof(int).
 */
#endif
#endif

/* Amount of stuff to slurp up with each read. */
#ifndef YY_READ_BUF_SIZE
#define YY_READ_BUF_SIZE 8192
#endif

/* Copy whatever the last rule matched to the standard output. */

#ifndef ECHO
/* This used to be an fputs(), but since the string might contain NUL's,
 * we now use fwrite().
 */
#define ECHO (void) fwrite( yytext, yyleng, 1, yyout )
#endif

/* Gets input and stuffs it into "buf".  number of characters read, or YY_NULL,
 * is returned in "result".
 */
#ifndef YY_INPUT
#define YY_INPUT(buf,result,max_size) \
	if ( yy_current_buffer->yy_is_interactive ) \
		{ \
		int c = '*', n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) \
		  && ferror( yyin ) ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );
#endif

/* No semi-colon after return; correct usage is to write "yyterminate();" -
 * we don't want an extra ';' after the "return" because that will cause
 * some compilers to complain about unreachable statements.
 */
#ifndef yyterminate
#define yyterminate() return YY_NULL
#endif

/* Number of entries by which start-condition stack grows. */
#ifndef YY_START_STACK_INCR
#define YY_START_STACK_INCR 25
#endif

/* Report a fatal error. */
#ifndef YY_FATAL_ERROR
#define YY_FATAL_ERROR(msg) yy_fatal_error( msg )
#endif

/* Default declaration of generated scanner - a define so the user can
 * easily add parameters.
 */
#ifndef YY_DECL
#define YY_DECL int yylex YY_PROTO(( void ))
#endif

/* Code executed at the beginning of each rule, after yytext and yyleng
 * have been set up.
 */
#ifndef YY_USER_ACTION
#define YY_USER_ACTION
#endif

/* Code executed at the end of each rule. */
#ifndef YY_BREAK
#define YY_BREAK break;
#endif

#define YY_RULE_SETUP \
	if ( yyleng > 0 ) \
		yy_current_buffer->yy_at_bol = \
				(yytext[yyleng - 1] == '\n'); \
	YY_USER_ACTION

YY_DECL
	{
	register yy_state_type yy_current_state;
	register char *yy_cp = NULL, *yy_bp = NULL;
	register int yy_act;



	if ( yy_init )
		{
		yy_init = 0;

#ifdef YY_USER_INIT
		YY_USER_INIT;
#endif

		if ( ! yy_start )
			yy_start = 1;	/* first start state */

		if ( ! yyin )
			yyin = stdin;

		if ( ! yyout )
			yyout = stdout;

		if ( ! yy_current_buffer )
			yy_current_buffer =
				yy_create_buffer( yyin, YY_BUF_SIZE );

		yy_load_buffer_state();
		}

	while ( 1 )		/* loops until end-of-file is reached */
		{
		yy_more_len = 0;
		if ( yy_more_flag )
			{
			yy_more_len = yy_c_buf_p - yytext_ptr;
			yy_more_flag = 0;
			}
		yy_cp = yy_c_buf_p;

		/* Support of yytext. */
		*yy_cp = yy_hold_char;

		/* yy_bp points to the position in yy_ch_buf of the start of
		 * the current run.
		 */
		yy_bp = yy_cp;

		yy_current_state = yy_start;
		yy_current_state += YY_AT_BOL();
		yy_state_ptr = yy_state_buf;
		*yy_state_ptr++ = yy_current_state;
yy_match:
		do
			{
			register YY_CHAR yy_c = yy_ec[YY_SC_TO_UI(*yy_cp)];
			while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
				{
				yy_current_state = (int) yy_def[yy_current_state];
				if ( yy_current_state >= 653 )
					yy_c = yy_meta[(unsigned int) yy_c];
				}
			yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
			*yy_state_ptr++ = yy_current_state;
			++yy_cp;
			}
		while ( yy_base[yy_current_state] != 1907 );

yy_find_action:
		yy_current_state = *--yy_state_ptr;
		yy_lp = yy_accept[yy_current_state];
find_rule: /* we branch to this label when backing up */
		for ( ; ; ) /* until we find what rule we matched */
			{
			if ( yy_lp && yy_lp < yy_accept[yy_current_state + 1] )
				{
				yy_act = yy_acclist[yy_lp];
				if ( yy_act & YY_TRAILING_HEAD_MASK ||
				     yy_looking_for_trail_begin )
					{
					if ( yy_act == yy_looking_for_trail_begin )
						{
						yy_looking_for_trail_begin = 0;
						yy_act &= ~YY_TRAILING_HEAD_MASK;
						break;
						}
					}
				else if ( yy_act & YY_TRAILING_MASK )
					{
					yy_looking_for_trail_begin = yy_act & ~YY_TRAILING_MASK;
					yy_looking_for_trail_begin |= YY_TRAILING_HEAD_MASK;
					}
				else
					{
					yy_full_match = yy_cp;
					yy_full_state = yy_state_ptr;
					yy_full_lp = yy_lp;
					break;
					}
				++yy_lp;
				goto find_rule;
				}
			--yy_cp;
			yy_current_state = *--yy_state_ptr;
			yy_lp = yy_accept[yy_current_state];
			}

		YY_DO_BEFORE_ACTION;


do_action:	/* This label is used only to access EOF actions. */


		switch ( yy_act )
	{ /* beginning of action switch */
case YY_STATE_EOF(INITIAL):
case YY_STATE_EOF(PRELNO):
case YY_STATE_EOF(PASTLNO):
case YY_STATE_EOF(IMPORT):
case YY_STATE_EOF(IMPORT_DONE):
{
  if (--include_stack_ptr<0) {
    return tEOPROG;
  } else {
    if (!is_bound) {
      yy_delete_buffer(YY_CURRENT_BUFFER);
      yy_switch_to_buffer(include_stack[include_stack_ptr]);
    }
    flex_line+=yylval.sep=-1;
    return tSEP;
  }
}
	YY_BREAK
case 1:
YY_RULE_SETUP
{BEGIN(INITIAL);}     /* ignore whitespace */
	YY_BREAK
case 2:
YY_RULE_SETUP
{BEGIN(PRELNO);return tLABEL;}
	YY_BREAK
case 3:
YY_RULE_SETUP
{
  BEGIN(PASTLNO);
  yylval.symbol=(char *)my_strdup(yytext);
  return tSYMBOL;
}
	YY_BREAK
case 4:
YY_RULE_SETUP
{BEGIN(INITIAL);flex_line+=yylval.sep=0;yyless(0);return tSEP;}
	YY_BREAK
case 5:
YY_RULE_SETUP
{if (fi_pending) {fi_pending--;yyless(0);return tENDIF;}BEGIN(INITIAL);flex_line+=yylval.sep=1;return tSEP;}
	YY_BREAK
case 6:
YY_RULE_SETUP
{if (fi_pending) {fi_pending--;yyless(0);return tENDIF;}if (interactive && !inlib) {return tEOPROG;} else {flex_line+=yylval.sep=2;return tSEP;}}
	YY_BREAK
case 7:
YY_RULE_SETUP
{if (fi_pending) {fi_pending--;yyless(0);return tENDIF;}flex_line+=yylval.sep=1;return tSEP;}
	YY_BREAK
case 8:
YY_RULE_SETUP
{if (fi_pending && check_compat) error_with_line(WARNING,"short-if has changed in version 2.71",flex_line);flex_line+=yylval.sep=0;return tSEP;}
	YY_BREAK
case 9:
YY_RULE_SETUP
{flex_line+=yylval.sep=0;return tSEP;}  /* comments span 'til end of line */
	YY_BREAK
case 10:
YY_RULE_SETUP
{flex_line+=yylval.sep=0;return tSEP;}  /* comments span 'til end of line */
	YY_BREAK
case 11:
YY_RULE_SETUP
{if (fi_pending) {fi_pending--;yyless(0);return tENDIF;}flex_line+=yylval.sep=1;return tSEP;}
	YY_BREAK
case 12:
YY_RULE_SETUP
{yymore();}
	YY_BREAK
case 13:
YY_RULE_SETUP
{BEGIN(IMPORT);}
	YY_BREAK
case 14:
YY_RULE_SETUP
{if (!import_lib(yytext)) return 0;BEGIN(IMPORT_DONE);return tIMPORT;}
	YY_BREAK
case 15:
YY_RULE_SETUP
{if (yytext[0]=='\n' && fi_pending) {fi_pending--;yyless(0);return tENDIF;}BEGIN(INITIAL);yyless(0);flex_line+=yylval.sep=0;return tSEP;}
	YY_BREAK
case 16:
YY_RULE_SETUP
{
  char *where=strpbrk(yytext," \t\r\f\v");
  yylval.docu=(char *)my_strdup(where ? where+1 : NULL);
  return tDOCU;
}
	YY_BREAK
case 17:
YY_RULE_SETUP
{flex_line+=yylval.sep=1;return tSEP;} /* '#' as first character may introduce comments too */
	YY_BREAK
case 18:
YY_RULE_SETUP
{flex_line+=yylval.sep=1;return tSEP;} /* ' as first character may introduce comments too */
	YY_BREAK
case 19:
YY_RULE_SETUP
return tEXECUTE;
	YY_BREAK
case 20:
YY_RULE_SETUP
return tEXECUTE2;
	YY_BREAK
case 21:
YY_RULE_SETUP
return tCOMPILE;
	YY_BREAK
case 22:
YY_RULE_SETUP
return tRUNTIME_CREATED_SUB;
	YY_BREAK
case 23:
YY_RULE_SETUP
return tENDSUB;
	YY_BREAK
case 24:
YY_RULE_SETUP
return tENDIF;
	YY_BREAK
case 25:
YY_RULE_SETUP
return tENDIF;
	YY_BREAK
case 26:
YY_RULE_SETUP
return tWEND;
	YY_BREAK
case 27:
YY_RULE_SETUP
return tWEND;
	YY_BREAK
case 28:
YY_RULE_SETUP
return tSEND;
	YY_BREAK
case 29:
YY_RULE_SETUP
return tSEND;
	YY_BREAK
case 30:
YY_RULE_SETUP
return tSEND;
	YY_BREAK
case 31:
YY_RULE_SETUP
return tSEND;
	YY_BREAK
case 32:
YY_RULE_SETUP
return tEXPORT;
	YY_BREAK
case 33:
YY_RULE_SETUP
return tERROR;
	YY_BREAK
case 34:
YY_RULE_SETUP
return tFOR;
	YY_BREAK
case 35:
YY_RULE_SETUP
return tBREAK;
	YY_BREAK
case 36:
YY_RULE_SETUP
return tSWITCH;
	YY_BREAK
case 37:
YY_RULE_SETUP
return tCASE;
	YY_BREAK
case 38:
YY_RULE_SETUP
return tDEFAULT;
	YY_BREAK
case 39:
YY_RULE_SETUP
return tLOOP;
	YY_BREAK
case 40:
YY_RULE_SETUP
return tDO;
	YY_BREAK
case 41:
YY_RULE_SETUP
return tTO;
	YY_BREAK
case 42:
YY_RULE_SETUP
return tAS;
	YY_BREAK
case 43:
YY_RULE_SETUP
return tREADING;
	YY_BREAK
case 44:
YY_RULE_SETUP
return tWRITING;
	YY_BREAK
case 45:
YY_RULE_SETUP
return tSTEP;
	YY_BREAK
case 46:
YY_RULE_SETUP
return tNEXT;
	YY_BREAK
case 47:
YY_RULE_SETUP
return tWHILE;
	YY_BREAK
case 48:
YY_RULE_SETUP
return tWEND;
	YY_BREAK
case 49:
YY_RULE_SETUP
return tREPEAT;
	YY_BREAK
case 50:
YY_RULE_SETUP
return tUNTIL;
	YY_BREAK
case 51:
YY_RULE_SETUP
return tGOTO;
	YY_BREAK
case 52:
YY_RULE_SETUP
return tGOSUB;
	YY_BREAK
case 53:
YY_RULE_SETUP
return tSUB;
	YY_BREAK
case 54:
YY_RULE_SETUP
return tSUB;
	YY_BREAK
case 55:
YY_RULE_SETUP
return tLOCAL;
	YY_BREAK
case 56:
YY_RULE_SETUP
return tSTATIC;
	YY_BREAK
case 57:
YY_RULE_SETUP
return tON;
	YY_BREAK
case 58:
YY_RULE_SETUP
return tINTERRUPT;
	YY_BREAK
case 59:
YY_RULE_SETUP
return tCONTINUE;
	YY_BREAK
case 60:
YY_RULE_SETUP
return tLABEL;
	YY_BREAK
case 61:
YY_RULE_SETUP
return tIF;
	YY_BREAK
case 62:
YY_RULE_SETUP
return tTHEN;
	YY_BREAK
case 63:
YY_RULE_SETUP
return tELSE;
	YY_BREAK
case 64:
YY_RULE_SETUP
return tELSIF;
	YY_BREAK
case 65:
YY_RULE_SETUP
return tELSIF;
	YY_BREAK
case 66:
YY_RULE_SETUP
return tENDIF;
	YY_BREAK
case 67:
YY_RULE_SETUP
return tENDIF;
	YY_BREAK
case 68:
YY_RULE_SETUP
return tOPEN;
	YY_BREAK
case 69:
YY_RULE_SETUP
return tCLOSE;
	YY_BREAK
case 70:
YY_RULE_SETUP
return tSEEK;
	YY_BREAK
case 71:
YY_RULE_SETUP
return tTELL;
	YY_BREAK
case 72:
YY_RULE_SETUP
return tPRINT;
	YY_BREAK
case 73:
YY_RULE_SETUP
return tUSING;
	YY_BREAK
case 74:
YY_RULE_SETUP
return tREVERSE;
	YY_BREAK
case 75:
YY_RULE_SETUP
return tCOLOUR;
	YY_BREAK
case 76:
YY_RULE_SETUP
return tCOLOUR;
	YY_BREAK
case 77:
YY_RULE_SETUP
return tPRINT;
	YY_BREAK
case 78:
YY_RULE_SETUP
return tINPUT;
	YY_BREAK
case 79:
YY_RULE_SETUP
return tRETURN;
	YY_BREAK
case 80:
YY_RULE_SETUP
return tDIM;
	YY_BREAK
case 81:
YY_RULE_SETUP
return tDIM;
	YY_BREAK
case 82:
YY_RULE_SETUP
return tEND;
	YY_BREAK
case 83:
YY_RULE_SETUP
return tEXIT;
	YY_BREAK
case 84:
YY_RULE_SETUP
return tREAD;
	YY_BREAK
case 85:
YY_RULE_SETUP
return tDATA;
	YY_BREAK
case 86:
YY_RULE_SETUP
return tRESTORE;
	YY_BREAK
case 87:
YY_RULE_SETUP
return tAND;
	YY_BREAK
case 88:
YY_RULE_SETUP
return tOR;
	YY_BREAK
case 89:
YY_RULE_SETUP
return tNOT;
	YY_BREAK
case 90:
YY_RULE_SETUP
return tEOR;
	YY_BREAK
case 91:
YY_RULE_SETUP
return tEOR;
	YY_BREAK
case 92:
YY_RULE_SETUP
return tWINDOW;
	YY_BREAK
case 93:
YY_RULE_SETUP
return tORIGIN;
	YY_BREAK
case 94:
YY_RULE_SETUP
return tPRINTER;
	YY_BREAK
case 95:
YY_RULE_SETUP
return tDOT;
	YY_BREAK
case 96:
YY_RULE_SETUP
return tLINE;
	YY_BREAK
case 97:
YY_RULE_SETUP
return tCURVE;
	YY_BREAK
case 98:
YY_RULE_SETUP
return tCIRCLE;
	YY_BREAK
case 99:
YY_RULE_SETUP
return tCLEAR;
	YY_BREAK
case 100:
YY_RULE_SETUP
return tFILL;
	YY_BREAK
case 101:
YY_RULE_SETUP
return tFILL;
	YY_BREAK
case 102:
YY_RULE_SETUP
return tTEXT;
	YY_BREAK
case 103:
YY_RULE_SETUP
return tRECT;
	YY_BREAK
case 104:
YY_RULE_SETUP
return tRECT;
	YY_BREAK
case 105:
YY_RULE_SETUP
return tRECT;
	YY_BREAK
case 106:
YY_RULE_SETUP
return tPUTBIT;
	YY_BREAK
case 107:
YY_RULE_SETUP
return tPUTBIT;
	YY_BREAK
case 108:
YY_RULE_SETUP
return tPUTBIT;
	YY_BREAK
case 109:
YY_RULE_SETUP
return tGETBIT;
	YY_BREAK
case 110:
YY_RULE_SETUP
return tGETBIT;
	YY_BREAK
case 111:
YY_RULE_SETUP
return tGETBIT;
	YY_BREAK
case 112:
YY_RULE_SETUP
return tPUTCHAR;
	YY_BREAK
case 113:
YY_RULE_SETUP
return tGETCHAR;
	YY_BREAK
case 114:
YY_RULE_SETUP
return tNEW;
	YY_BREAK
case 115:
YY_RULE_SETUP
return tWAIT;
	YY_BREAK
case 116:
YY_RULE_SETUP
return tWAIT;
	YY_BREAK
case 117:
YY_RULE_SETUP
return tWAIT;
	YY_BREAK
case 118:
YY_RULE_SETUP
return tBELL;
	YY_BREAK
case 119:
YY_RULE_SETUP
return tBELL;
	YY_BREAK
case 120:
YY_RULE_SETUP
return tLET;
	YY_BREAK
case 121:
YY_RULE_SETUP
return tARDIM;
	YY_BREAK
case 122:
YY_RULE_SETUP
return tARDIM;
	YY_BREAK
case 123:
YY_RULE_SETUP
return tARSIZE;
	YY_BREAK
case 124:
YY_RULE_SETUP
{yylval.symbol=(char *)my_strdup("numparams"); return tSYMBOL;}
	YY_BREAK
case 125:
YY_RULE_SETUP
return tBIND;
	YY_BREAK
case 126:
YY_RULE_SETUP
return tSIN;
	YY_BREAK
case 127:
YY_RULE_SETUP
return tASIN;
	YY_BREAK
case 128:
YY_RULE_SETUP
return tCOS;
	YY_BREAK
case 129:
YY_RULE_SETUP
return tACOS;
	YY_BREAK
case 130:
YY_RULE_SETUP
return tTAN;
	YY_BREAK
case 131:
YY_RULE_SETUP
return tATAN;
	YY_BREAK
case 132:
YY_RULE_SETUP
return tEXP;
	YY_BREAK
case 133:
YY_RULE_SETUP
return tLOG;
	YY_BREAK
case 134:
YY_RULE_SETUP
return tSQRT;
	YY_BREAK
case 135:
YY_RULE_SETUP
return tSQR;
	YY_BREAK
case 136:
YY_RULE_SETUP
return tINT;
	YY_BREAK
case 137:
YY_RULE_SETUP
return tFRAC;
	YY_BREAK
case 138:
YY_RULE_SETUP
return tABS;
	YY_BREAK
case 139:
YY_RULE_SETUP
return tSIG;
	YY_BREAK
case 140:
YY_RULE_SETUP
return tMOD;
	YY_BREAK
case 141:
YY_RULE_SETUP
return tRAN;
	YY_BREAK
case 142:
YY_RULE_SETUP
return tMIN;
	YY_BREAK
case 143:
YY_RULE_SETUP
return tMAX;
	YY_BREAK
case 144:
YY_RULE_SETUP
return tLEFT;
	YY_BREAK
case 145:
YY_RULE_SETUP
return tRIGHT;
	YY_BREAK
case 146:
YY_RULE_SETUP
return tMID;
	YY_BREAK
case 147:
YY_RULE_SETUP
return tLOWER;
	YY_BREAK
case 148:
YY_RULE_SETUP
return tUPPER;
	YY_BREAK
case 149:
YY_RULE_SETUP
return tLTRIM;
	YY_BREAK
case 150:
YY_RULE_SETUP
return tRTRIM;
	YY_BREAK
case 151:
YY_RULE_SETUP
return tTRIM;
	YY_BREAK
case 152:
YY_RULE_SETUP
return tINSTR;
	YY_BREAK
case 153:
YY_RULE_SETUP
return tRINSTR;
	YY_BREAK
case 154:
YY_RULE_SETUP
return tLEN;
	YY_BREAK
case 155:
YY_RULE_SETUP
return tVAL;
	YY_BREAK
case 156:
YY_RULE_SETUP
return tMYEOF;
	YY_BREAK
case 157:
YY_RULE_SETUP
return tSTR;
	YY_BREAK
case 158:
YY_RULE_SETUP
return tINKEY;
	YY_BREAK
case 159:
YY_RULE_SETUP
return tMOUSEX;
	YY_BREAK
case 160:
YY_RULE_SETUP
return tMOUSEY;
	YY_BREAK
case 161:
YY_RULE_SETUP
return tMOUSEB;
	YY_BREAK
case 162:
YY_RULE_SETUP
return tMOUSEB;
	YY_BREAK
case 163:
YY_RULE_SETUP
return tMOUSEMOD;
	YY_BREAK
case 164:
YY_RULE_SETUP
return tMOUSEMOD;
	YY_BREAK
case 165:
YY_RULE_SETUP
return tCHR;
	YY_BREAK
case 166:
YY_RULE_SETUP
return tASC;
	YY_BREAK
case 167:
YY_RULE_SETUP
return tHEX;
	YY_BREAK
case 168:
YY_RULE_SETUP
return tBIN;
	YY_BREAK
case 169:
YY_RULE_SETUP
return tDEC;
	YY_BREAK
case 170:
YY_RULE_SETUP
return tAT;
	YY_BREAK
case 171:
YY_RULE_SETUP
return tAT;
	YY_BREAK
case 172:
YY_RULE_SETUP
return tSCREEN;
	YY_BREAK
case 173:
YY_RULE_SETUP
return tSYSTEM;
	YY_BREAK
case 174:
YY_RULE_SETUP
return tSYSTEM2;
	YY_BREAK
case 175:
YY_RULE_SETUP
return tDATE;
	YY_BREAK
case 176:
YY_RULE_SETUP
return tTIME;
	YY_BREAK
case 177:
YY_RULE_SETUP
return tPEEK;
	YY_BREAK
case 178:
YY_RULE_SETUP
return tPEEK2;
	YY_BREAK
case 179:
YY_RULE_SETUP
return tPOKE;
	YY_BREAK
case 180:
YY_RULE_SETUP
return tTOKEN;
	YY_BREAK
case 181:
YY_RULE_SETUP
return tTOKENALT;
	YY_BREAK
case 182:
YY_RULE_SETUP
return tSPLIT;
	YY_BREAK
case 183:
YY_RULE_SETUP
return tSPLITALT;
	YY_BREAK
case 184:
YY_RULE_SETUP
return tGLOB;
	YY_BREAK
case 185:
YY_RULE_SETUP
return tPOW;
	YY_BREAK
case 186:
YY_RULE_SETUP
return tPOW;
	YY_BREAK
case 187:
YY_RULE_SETUP
return tNEQ;
	YY_BREAK
case 188:
YY_RULE_SETUP
return tLEQ;
	YY_BREAK
case 189:
YY_RULE_SETUP
return tGEQ;
	YY_BREAK
case 190:
YY_RULE_SETUP
return tEQU;
	YY_BREAK
case 191:
YY_RULE_SETUP
return tLTN;
	YY_BREAK
case 192:
YY_RULE_SETUP
return tGTN;
	YY_BREAK
case 193:
YY_RULE_SETUP
return tNOT;
	YY_BREAK
case 194:
YY_RULE_SETUP
{return yytext[0];}
	YY_BREAK
case 195:
YY_RULE_SETUP
{
  yylval.digits=(char *)my_strdup(yytext);
  return tDIGITS;
}
	YY_BREAK
case 196:
YY_RULE_SETUP
{
  { double d;
    sscanf(yytext,"%lg",&d);
    yylval.fnum=d;
    return tFNUM;
  }
}
	YY_BREAK
case 197:
YY_RULE_SETUP
{yylval.fnum=3.1415926535897932;return tFNUM;}
	YY_BREAK
case 198:
YY_RULE_SETUP
{yylval.fnum=2.7182818284590452;return tFNUM;}
	YY_BREAK
case 199:
YY_RULE_SETUP
{yylval.fnum=1; return tFNUM;}
	YY_BREAK
case 200:
YY_RULE_SETUP
{yylval.fnum=0; return tFNUM;}
	YY_BREAK
case 201:
YY_RULE_SETUP
{
  yylval.symbol=(char *)my_strdup(yytext);
  return tSYMBOL;
}
	YY_BREAK
/* Symbols with a trailing $-sign are treated special */
case 202:
YY_RULE_SETUP
{
  yylval.symbol=(char *)my_strdup(yytext);
  return tSTRSYM;
}
	YY_BREAK
case 203:
YY_RULE_SETUP
{
  int cnt;
  if (yytext[yyleng-1]=='\n' && fi_pending) {fi_pending--;yyless(0);return tENDIF;}
  if (yytext[yyleng-1]=='\n') {
  	yylval.string=NULL;
  	return tSTRING;
  }
  for(cnt=0;yytext[yyleng-cnt-2]=='\\';cnt++) ;
  if (cnt%2) {
  	yyless(yyleng-1);
	yymore();
  } else {
	yylval.string=(char *)my_strdup(yytext+1);
	*(yylval.string+yyleng-2)='\0';
	replace(yylval.string);
	return tSTRING;
  }
}
	YY_BREAK
case 204:
YY_RULE_SETUP
{if (isprint(yytext[0])) return yytext[0]; else return ' ';}
	YY_BREAK
case 205:
YY_RULE_SETUP
YY_FATAL_ERROR( "flex scanner jammed" );
	YY_BREAK

	case YY_END_OF_BUFFER:
		{
		/* Amount of text matched not including the EOB char. */
		int yy_amount_of_matched_text = (int) (yy_cp - yytext_ptr) - 1;

		/* Undo the effects of YY_DO_BEFORE_ACTION. */
		*yy_cp = yy_hold_char;
		YY_RESTORE_YY_MORE_OFFSET

		if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_NEW )
			{
			/* We're scanning a new file or input source.  It's
			 * possible that this happened because the user
			 * just pointed yyin at a new source and called
			 * yylex().  If so, then we have to assure
			 * consistency between yy_current_buffer and our
			 * globals.  Here is the right place to do so, because
			 * this is the first action (other than possibly a
			 * back-up) that will match for the new input source.
			 */
			yy_n_chars = yy_current_buffer->yy_n_chars;
			yy_current_buffer->yy_input_file = yyin;
			yy_current_buffer->yy_buffer_status = YY_BUFFER_NORMAL;
			}

		/* Note that here we test for yy_c_buf_p "<=" to the position
		 * of the first EOB in the buffer, since yy_c_buf_p will
		 * already have been incremented past the NUL character
		 * (since all states make transitions on EOB to the
		 * end-of-buffer state).  Contrast this with the test
		 * in input().
		 */
		if ( yy_c_buf_p <= &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			{ /* This was really a NUL. */
			yy_state_type yy_next_state;

			yy_c_buf_p = yytext_ptr + yy_amount_of_matched_text;

			yy_current_state = yy_get_previous_state();

			/* Okay, we're now positioned to make the NUL
			 * transition.  We couldn't have
			 * yy_get_previous_state() go ahead and do it
			 * for us because it doesn't know how to deal
			 * with the possibility of jamming (and we don't
			 * want to build jamming into it because then it
			 * will run more slowly).
			 */

			yy_next_state = yy_try_NUL_trans( yy_current_state );

			yy_bp = yytext_ptr + YY_MORE_ADJ;

			if ( yy_next_state )
				{
				/* Consume the NUL. */
				yy_cp = ++yy_c_buf_p;
				yy_current_state = yy_next_state;
				goto yy_match;
				}

			else
				{
				yy_cp = yy_c_buf_p;
				goto yy_find_action;
				}
			}

		else switch ( yy_get_next_buffer() )
			{
			case EOB_ACT_END_OF_FILE:
				{
				yy_did_buffer_switch_on_eof = 0;

				if ( yywrap() )
					{
					/* Note: because we've taken care in
					 * yy_get_next_buffer() to have set up
					 * yytext, we can now set up
					 * yy_c_buf_p so that if some total
					 * hoser (like flex itself) wants to
					 * call the scanner after we return the
					 * YY_NULL, it'll still work - another
					 * YY_NULL will get returned.
					 */
					yy_c_buf_p = yytext_ptr + YY_MORE_ADJ;

					yy_act = YY_STATE_EOF(YY_START);
					goto do_action;
					}

				else
					{
					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
					}
				break;
				}

			case EOB_ACT_CONTINUE_SCAN:
				yy_c_buf_p =
					yytext_ptr + yy_amount_of_matched_text;

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_match;

			case EOB_ACT_LAST_MATCH:
				yy_c_buf_p =
				&yy_current_buffer->yy_ch_buf[yy_n_chars];

				yy_current_state = yy_get_previous_state();

				yy_cp = yy_c_buf_p;
				yy_bp = yytext_ptr + YY_MORE_ADJ;
				goto yy_find_action;
			}
		break;
		}

	default:
		YY_FATAL_ERROR(
			"fatal flex scanner internal error--no action found" );
	} /* end of action switch */
		} /* end of scanning one token */
	} /* end of yylex */


/* yy_get_next_buffer - try to read in a new buffer
 *
 * Returns a code representing an action:
 *	EOB_ACT_LAST_MATCH -
 *	EOB_ACT_CONTINUE_SCAN - continue scanning from current position
 *	EOB_ACT_END_OF_FILE - end of file
 */

static int yy_get_next_buffer()
	{
	register char *dest = yy_current_buffer->yy_ch_buf;
	register char *source = yytext_ptr;
	register int number_to_move, i;
	int ret_val;

	if ( yy_c_buf_p > &yy_current_buffer->yy_ch_buf[yy_n_chars + 1] )
		YY_FATAL_ERROR(
		"fatal flex scanner internal error--end of buffer missed" );

	if ( yy_current_buffer->yy_fill_buffer == 0 )
		{ /* Don't try to fill the buffer, so this is an EOF. */
		if ( yy_c_buf_p - yytext_ptr - YY_MORE_ADJ == 1 )
			{
			/* We matched a single character, the EOB, so
			 * treat this as a final EOF.
			 */
			return EOB_ACT_END_OF_FILE;
			}

		else
			{
			/* We matched some text prior to the EOB, first
			 * process it.
			 */
			return EOB_ACT_LAST_MATCH;
			}
		}

	/* Try to read more data. */

	/* First move last chars to start of buffer. */
	number_to_move = (int) (yy_c_buf_p - yytext_ptr) - 1;

	for ( i = 0; i < number_to_move; ++i )
		*(dest++) = *(source++);

	if ( yy_current_buffer->yy_buffer_status == YY_BUFFER_EOF_PENDING )
		/* don't do the read, it's not guaranteed to return an EOF,
		 * just force an EOF
		 */
		yy_current_buffer->yy_n_chars = yy_n_chars = 0;

	else
		{
		int num_to_read =
			yy_current_buffer->yy_buf_size - number_to_move - 1;

		while ( num_to_read <= 0 )
			{ /* Not enough room in the buffer - grow it. */
#ifdef YY_USES_REJECT
			YY_FATAL_ERROR(
"input buffer overflow, can't enlarge buffer because scanner uses REJECT" );
#else

			/* just a shorter name for the current buffer */
			YY_BUFFER_STATE b = yy_current_buffer;

			int yy_c_buf_p_offset =
				(int) (yy_c_buf_p - b->yy_ch_buf);

			if ( b->yy_is_our_buffer )
				{
				int new_size = b->yy_buf_size * 2;

				if ( new_size <= 0 )
					b->yy_buf_size += b->yy_buf_size / 8;
				else
					b->yy_buf_size *= 2;

				b->yy_ch_buf = (char *)
					/* Include room in for 2 EOB chars. */
					yy_flex_realloc( (void *) b->yy_ch_buf,
							 b->yy_buf_size + 2 );
				}
			else
				/* Can't grow it, we don't own it. */
				b->yy_ch_buf = 0;

			if ( ! b->yy_ch_buf )
				YY_FATAL_ERROR(
				"fatal error - scanner input buffer overflow" );

			yy_c_buf_p = &b->yy_ch_buf[yy_c_buf_p_offset];

			num_to_read = yy_current_buffer->yy_buf_size -
						number_to_move - 1;
#endif
			}

		if ( num_to_read > YY_READ_BUF_SIZE )
			num_to_read = YY_READ_BUF_SIZE;

		/* Read in more data. */
		YY_INPUT( (&yy_current_buffer->yy_ch_buf[number_to_move]),
			yy_n_chars, num_to_read );

		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	if ( yy_n_chars == 0 )
		{
		if ( number_to_move == YY_MORE_ADJ )
			{
			ret_val = EOB_ACT_END_OF_FILE;
			yyrestart( yyin );
			}

		else
			{
			ret_val = EOB_ACT_LAST_MATCH;
			yy_current_buffer->yy_buffer_status =
				YY_BUFFER_EOF_PENDING;
			}
		}

	else
		ret_val = EOB_ACT_CONTINUE_SCAN;

	yy_n_chars += number_to_move;
	yy_current_buffer->yy_ch_buf[yy_n_chars] = YY_END_OF_BUFFER_CHAR;
	yy_current_buffer->yy_ch_buf[yy_n_chars + 1] = YY_END_OF_BUFFER_CHAR;

	yytext_ptr = &yy_current_buffer->yy_ch_buf[0];

	return ret_val;
	}


/* yy_get_previous_state - get the state just before the EOB char was reached */

static yy_state_type yy_get_previous_state()
	{
	register yy_state_type yy_current_state;
	register char *yy_cp;

	yy_current_state = yy_start;
	yy_current_state += YY_AT_BOL();
	yy_state_ptr = yy_state_buf;
	*yy_state_ptr++ = yy_current_state;

	for ( yy_cp = yytext_ptr + YY_MORE_ADJ; yy_cp < yy_c_buf_p; ++yy_cp )
		{
		register YY_CHAR yy_c = (*yy_cp ? yy_ec[YY_SC_TO_UI(*yy_cp)] : 1);
		while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
			{
			yy_current_state = (int) yy_def[yy_current_state];
			if ( yy_current_state >= 653 )
				yy_c = yy_meta[(unsigned int) yy_c];
			}
		yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
		*yy_state_ptr++ = yy_current_state;
		}

	return yy_current_state;
	}


/* yy_try_NUL_trans - try to make a transition on the NUL character
 *
 * synopsis
 *	next_state = yy_try_NUL_trans( current_state );
 */

#ifdef YY_USE_PROTOS
static yy_state_type yy_try_NUL_trans( yy_state_type yy_current_state )
#else
static yy_state_type yy_try_NUL_trans( yy_current_state )
yy_state_type yy_current_state;
#endif
	{
	register int yy_is_jam;

	register YY_CHAR yy_c = 1;
	while ( yy_chk[yy_base[yy_current_state] + yy_c] != yy_current_state )
		{
		yy_current_state = (int) yy_def[yy_current_state];
		if ( yy_current_state >= 653 )
			yy_c = yy_meta[(unsigned int) yy_c];
		}
	yy_current_state = yy_nxt[yy_base[yy_current_state] + (unsigned int) yy_c];
	yy_is_jam = (yy_current_state == 652);
	if ( ! yy_is_jam )
		*yy_state_ptr++ = yy_current_state;

	return yy_is_jam ? 0 : yy_current_state;
	}


#ifndef YY_NO_UNPUT
#ifdef YY_USE_PROTOS
static void yyunput( int c, register char *yy_bp )
#else
static void yyunput( c, yy_bp )
int c;
register char *yy_bp;
#endif
	{
	register char *yy_cp = yy_c_buf_p;

	/* undo effects of setting up yytext */
	*yy_cp = yy_hold_char;

	if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
		{ /* need to shift things up to make room */
		/* +2 for EOB chars. */
		register int number_to_move = yy_n_chars + 2;
		register char *dest = &yy_current_buffer->yy_ch_buf[
					yy_current_buffer->yy_buf_size + 2];
		register char *source =
				&yy_current_buffer->yy_ch_buf[number_to_move];

		while ( source > yy_current_buffer->yy_ch_buf )
			*--dest = *--source;

		yy_cp += (int) (dest - source);
		yy_bp += (int) (dest - source);
		yy_current_buffer->yy_n_chars =
			yy_n_chars = yy_current_buffer->yy_buf_size;

		if ( yy_cp < yy_current_buffer->yy_ch_buf + 2 )
			YY_FATAL_ERROR( "flex scanner push-back overflow" );
		}

	*--yy_cp = (char) c;


	yytext_ptr = yy_bp;
	yy_hold_char = *yy_cp;
	yy_c_buf_p = yy_cp;
	}
#endif	/* ifndef YY_NO_UNPUT */


#ifndef YY_NO_INPUT
#ifdef __cplusplus
static int yyinput()
#else
static int input()
#endif
	{
	int c;

	*yy_c_buf_p = yy_hold_char;

	if ( *yy_c_buf_p == YY_END_OF_BUFFER_CHAR )
		{
		/* yy_c_buf_p now points to the character we want to return.
		 * If this occurs *before* the EOB characters, then it's a
		 * valid NUL; if not, then we've hit the end of the buffer.
		 */
		if ( yy_c_buf_p < &yy_current_buffer->yy_ch_buf[yy_n_chars] )
			/* This was really a NUL. */
			*yy_c_buf_p = '\0';

		else
			{ /* need more input */
			int offset = yy_c_buf_p - yytext_ptr;
			++yy_c_buf_p;

			switch ( yy_get_next_buffer() )
				{
				case EOB_ACT_LAST_MATCH:
					/* This happens because yy_g_n_b()
					 * sees that we've accumulated a
					 * token and flags that we need to
					 * try matching the token before
					 * proceeding.  But for input(),
					 * there's no matching to consider.
					 * So convert the EOB_ACT_LAST_MATCH
					 * to EOB_ACT_END_OF_FILE.
					 */

					/* Reset buffer status. */
					yyrestart( yyin );

					/* fall through */

				case EOB_ACT_END_OF_FILE:
					{
					if ( yywrap() )
						return EOF;

					if ( ! yy_did_buffer_switch_on_eof )
						YY_NEW_FILE;
#ifdef __cplusplus
					return yyinput();
#else
					return input();
#endif
					}

				case EOB_ACT_CONTINUE_SCAN:
					yy_c_buf_p = yytext_ptr + offset;
					break;
				}
			}
		}

	c = *(unsigned char *) yy_c_buf_p;	/* cast for 8-bit char's */
	*yy_c_buf_p = '\0';	/* preserve yytext */
	yy_hold_char = *++yy_c_buf_p;

	yy_current_buffer->yy_at_bol = (c == '\n');

	return c;
	}
#endif /* YY_NO_INPUT */

#ifdef YY_USE_PROTOS
void yyrestart( FILE *input_file )
#else
void yyrestart( input_file )
FILE *input_file;
#endif
	{
	if ( ! yy_current_buffer )
		yy_current_buffer = yy_create_buffer( yyin, YY_BUF_SIZE );

	yy_init_buffer( yy_current_buffer, input_file );
	yy_load_buffer_state();
	}


#ifdef YY_USE_PROTOS
void yy_switch_to_buffer( YY_BUFFER_STATE new_buffer )
#else
void yy_switch_to_buffer( new_buffer )
YY_BUFFER_STATE new_buffer;
#endif
	{
	if ( yy_current_buffer == new_buffer )
		return;

	if ( yy_current_buffer )
		{
		/* Flush out information for old buffer. */
		*yy_c_buf_p = yy_hold_char;
		yy_current_buffer->yy_buf_pos = yy_c_buf_p;
		yy_current_buffer->yy_n_chars = yy_n_chars;
		}

	yy_current_buffer = new_buffer;
	yy_load_buffer_state();

	/* We don't actually know whether we did this switch during
	 * EOF (yywrap()) processing, but the only time this flag
	 * is looked at is after yywrap() is called, so it's safe
	 * to go ahead and always set it.
	 */
	yy_did_buffer_switch_on_eof = 1;
	}


#ifdef YY_USE_PROTOS
void yy_load_buffer_state( void )
#else
void yy_load_buffer_state()
#endif
	{
	yy_n_chars = yy_current_buffer->yy_n_chars;
	yytext_ptr = yy_c_buf_p = yy_current_buffer->yy_buf_pos;
	yyin = yy_current_buffer->yy_input_file;
	yy_hold_char = *yy_c_buf_p;
	}


#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_create_buffer( FILE *file, int size )
#else
YY_BUFFER_STATE yy_create_buffer( file, size )
FILE *file;
int size;
#endif
	{
	YY_BUFFER_STATE b;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_buf_size = size;

	/* yy_ch_buf has to be 2 characters longer than the size given because
	 * we need to put in 2 end-of-buffer characters.
	 */
	b->yy_ch_buf = (char *) yy_flex_alloc( b->yy_buf_size + 2 );
	if ( ! b->yy_ch_buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_create_buffer()" );

	b->yy_is_our_buffer = 1;

	yy_init_buffer( b, file );

	return b;
	}


#ifdef YY_USE_PROTOS
void yy_delete_buffer( YY_BUFFER_STATE b )
#else
void yy_delete_buffer( b )
YY_BUFFER_STATE b;
#endif
	{
	if ( ! b )
		return;

	if ( b == yy_current_buffer )
		yy_current_buffer = (YY_BUFFER_STATE) 0;

	if ( b->yy_is_our_buffer )
		yy_flex_free( (void *) b->yy_ch_buf );

	yy_flex_free( (void *) b );
	}



#ifdef YY_USE_PROTOS
void yy_init_buffer( YY_BUFFER_STATE b, FILE *file )
#else
void yy_init_buffer( b, file )
YY_BUFFER_STATE b;
FILE *file;
#endif


	{
	yy_flush_buffer( b );

	b->yy_input_file = file;
	b->yy_fill_buffer = 1;

#if YY_ALWAYS_INTERACTIVE
	b->yy_is_interactive = 1;
#else
#if YY_NEVER_INTERACTIVE
	b->yy_is_interactive = 0;
#else
	b->yy_is_interactive = file ? (isatty( fileno(file) ) > 0) : 0;
#endif
#endif
	}


#ifdef YY_USE_PROTOS
void yy_flush_buffer( YY_BUFFER_STATE b )
#else
void yy_flush_buffer( b )
YY_BUFFER_STATE b;
#endif

	{
	if ( ! b )
		return;

	b->yy_n_chars = 0;

	/* We always need two end-of-buffer characters.  The first causes
	 * a transition to the end-of-buffer state.  The second causes
	 * a jam in that state.
	 */
	b->yy_ch_buf[0] = YY_END_OF_BUFFER_CHAR;
	b->yy_ch_buf[1] = YY_END_OF_BUFFER_CHAR;

	b->yy_buf_pos = &b->yy_ch_buf[0];

	b->yy_at_bol = 1;
	b->yy_buffer_status = YY_BUFFER_NEW;

	if ( b == yy_current_buffer )
		yy_load_buffer_state();
	}


#ifndef YY_NO_SCAN_BUFFER
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_buffer( char *base, yy_size_t size )
#else
YY_BUFFER_STATE yy_scan_buffer( base, size )
char *base;
yy_size_t size;
#endif
	{
	YY_BUFFER_STATE b;

	if ( size < 2 ||
	     base[size-2] != YY_END_OF_BUFFER_CHAR ||
	     base[size-1] != YY_END_OF_BUFFER_CHAR )
		/* They forgot to leave room for the EOB's. */
		return 0;

	b = (YY_BUFFER_STATE) yy_flex_alloc( sizeof( struct yy_buffer_state ) );
	if ( ! b )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_buffer()" );

	b->yy_buf_size = size - 2;	/* "- 2" to take care of EOB's */
	b->yy_buf_pos = b->yy_ch_buf = base;
	b->yy_is_our_buffer = 0;
	b->yy_input_file = 0;
	b->yy_n_chars = b->yy_buf_size;
	b->yy_is_interactive = 0;
	b->yy_at_bol = 1;
	b->yy_fill_buffer = 0;
	b->yy_buffer_status = YY_BUFFER_NEW;

	yy_switch_to_buffer( b );

	return b;
	}
#endif


#ifndef YY_NO_SCAN_STRING
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_string( yyconst char *yy_str )
#else
YY_BUFFER_STATE yy_scan_string( yy_str )
yyconst char *yy_str;
#endif
	{
	int len;
	for ( len = 0; yy_str[len]; ++len )
		;

	return yy_scan_bytes( yy_str, len );
	}
#endif


#ifndef YY_NO_SCAN_BYTES
#ifdef YY_USE_PROTOS
YY_BUFFER_STATE yy_scan_bytes( yyconst char *bytes, int len )
#else
YY_BUFFER_STATE yy_scan_bytes( bytes, len )
yyconst char *bytes;
int len;
#endif
	{
	YY_BUFFER_STATE b;
	char *buf;
	yy_size_t n;
	int i;

	/* Get memory for full buffer, including space for trailing EOB's. */
	n = len + 2;
	buf = (char *) yy_flex_alloc( n );
	if ( ! buf )
		YY_FATAL_ERROR( "out of dynamic memory in yy_scan_bytes()" );

	for ( i = 0; i < len; ++i )
		buf[i] = bytes[i];

	buf[len] = buf[len+1] = YY_END_OF_BUFFER_CHAR;

	b = yy_scan_buffer( buf, n );
	if ( ! b )
		YY_FATAL_ERROR( "bad buffer in yy_scan_bytes()" );

	/* It's okay to grow etc. this buffer, and we should throw it
	 * away when we're done.
	 */
	b->yy_is_our_buffer = 1;

	return b;
	}
#endif


#ifndef YY_NO_PUSH_STATE
#ifdef YY_USE_PROTOS
static void yy_push_state( int new_state )
#else
static void yy_push_state( new_state )
int new_state;
#endif
	{
	if ( yy_start_stack_ptr >= yy_start_stack_depth )
		{
		yy_size_t new_size;

		yy_start_stack_depth += YY_START_STACK_INCR;
		new_size = yy_start_stack_depth * sizeof( int );

		if ( ! yy_start_stack )
			yy_start_stack = (int *) yy_flex_alloc( new_size );

		else
			yy_start_stack = (int *) yy_flex_realloc(
					(void *) yy_start_stack, new_size );

		if ( ! yy_start_stack )
			YY_FATAL_ERROR(
			"out of memory expanding start-condition stack" );
		}

	yy_start_stack[yy_start_stack_ptr++] = YY_START;

	BEGIN(new_state);
	}
#endif


#ifndef YY_NO_POP_STATE
static void yy_pop_state()
	{
	if ( --yy_start_stack_ptr < 0 )
		YY_FATAL_ERROR( "start-condition stack underflow" );

	BEGIN(yy_start_stack[yy_start_stack_ptr]);
	}
#endif


#ifndef YY_NO_TOP_STATE
static int yy_top_state()
	{
	return yy_start_stack[yy_start_stack_ptr - 1];
	}
#endif

#ifndef YY_EXIT_FAILURE
#define YY_EXIT_FAILURE 2
#endif

#ifdef YY_USE_PROTOS
static void yy_fatal_error( yyconst char msg[] )
#else
static void yy_fatal_error( msg )
char msg[];
#endif
	{
	(void) fprintf( stderr, "%s\n", msg );
	exit( YY_EXIT_FAILURE );
	}



/* Redefine yyless() so it works in section 3 code. */

#undef yyless
#define yyless(n) \
	do \
		{ \
		/* Undo effects of setting up yytext. */ \
		yytext[yyleng] = yy_hold_char; \
		yy_c_buf_p = yytext + n; \
		yy_hold_char = *yy_c_buf_p; \
		*yy_c_buf_p = '\0'; \
		yyleng = n; \
		} \
	while ( 0 )


/* Internal utility routines. */

#ifndef yytext_ptr
#ifdef YY_USE_PROTOS
static void yy_flex_strncpy( char *s1, yyconst char *s2, int n )
#else
static void yy_flex_strncpy( s1, s2, n )
char *s1;
yyconst char *s2;
int n;
#endif
	{
	register int i;
	for ( i = 0; i < n; ++i )
		s1[i] = s2[i];
	}
#endif

#ifdef YY_NEED_STRLEN
#ifdef YY_USE_PROTOS
static int yy_flex_strlen( yyconst char *s )
#else
static int yy_flex_strlen( s )
yyconst char *s;
#endif
	{
	register int n;
	for ( n = 0; s[n]; ++n )
		;

	return n;
	}
#endif


#ifdef YY_USE_PROTOS
static void *yy_flex_alloc( yy_size_t size )
#else
static void *yy_flex_alloc( size )
yy_size_t size;
#endif
	{
	return (void *) malloc( size );
	}

#ifdef YY_USE_PROTOS
static void *yy_flex_realloc( void *ptr, yy_size_t size )
#else
static void *yy_flex_realloc( ptr, size )
void *ptr;
yy_size_t size;
#endif
	{
	/* The cast to (char *) in the following accommodates both
	 * implementations that use char* generic pointers, and those
	 * that use void* generic pointers.  It works with the latter
	 * because both ANSI C and C++ allow castless assignment from
	 * any pointer type to void*, and deal with argument conversions
	 * as though doing an assignment.
	 */
	return (void *) realloc( (char *) ptr, size );
	}

#ifdef YY_USE_PROTOS
static void yy_flex_free( void *ptr )
#else
static void yy_flex_free( ptr )
void *ptr;
#endif
	{
	free( ptr );
	}

#if YY_MAIN
int main()
	{
	yylex();
	return 0;
	}
#endif

void yyerror(char *msg)
{
  int i,j;
  
  sprintf(string,"%s at %n",msg,&j);
  if (*yytext=='\n' || *yytext=='\0') {
    sprintf(string+j,"end of line");
  } else {
    i=0;
    string[j++]='\"';
    while(yytext[i]) {
      if (isprint(yytext[i])) string[j++]=yytext[i++];
      else {
	sprintf(string+j,"0x%02x",yytext[i]);
	j+=4;
	break;
      }
    }
    string[j++]='\"';
    string[j]='\0';
  }
  error(ERROR,string);		
  return;
}


void open_main(FILE *file,char *explicit,char *main_file_name) /* open main file */
{
  include_stack_ptr=0;
  
  if (explicit) 
    include_stack[include_stack_ptr]=yy_scan_string(explicit);
  else
    include_stack[include_stack_ptr]=yy_create_buffer(file,YY_BUF_SIZE);
  libfile_stack[include_stack_ptr]=new_file(main_file_name,"main");
  libfile_chain[libfile_chain_length++]=libfile_stack[include_stack_ptr];
  if (!explicit) yy_switch_to_buffer(include_stack[include_stack_ptr]);
  currlib=libfile_stack[0];
  inlib=FALSE;
  
  return;
}

void open_string(char *cmd) /* open string with commands */
{
  yy_switch_to_buffer(yy_scan_string(cmd));
}


int import_lib(char *name) /* import library */
{
  char *full;
  static int end_of_import=FALSE;

  if (!*name) name=pop(stSTRING)->pointer;
  while(isspace(*name)) name++;

  if (!strcmp(name,"__END_OF_IMPORT")) end_of_import=TRUE;
  if (end_of_import) return TRUE;

  /* start line numbers anew */
  libfile_stack[include_stack_ptr]->lineno=yylineno;
 
  include_stack_ptr++;
  if (include_stack_ptr>=MAX_INCLUDE_DEPTH) {
    sprintf(string,"Could not import '%s': nested too deep",name);
    error(ERROR,string);
    return FALSE;
  }

  if (is_bound) {
    full=name;
  } else {
    yyin=open_library(name,&full,FALSE);
    if (!yyin) return FALSE;
    yy_switch_to_buffer(yy_create_buffer(yyin,YY_BUF_SIZE));
    include_stack[include_stack_ptr]=YY_CURRENT_BUFFER;
  }
  libfile_stack[include_stack_ptr]=new_file(full,NULL);
  libfile_chain[libfile_chain_length++]=libfile_stack[include_stack_ptr];
  if (libfile_chain_length>=MAX_INCLUDE_NUMBER) {
    sprintf(string,"Cannot import more than %d libraries",MAX_INCLUDE_NUMBER);
    error(ERROR,string);
    return FALSE;
  }
  if (!libfile_stack[include_stack_ptr]) {
    sprintf(string,"library '%s' has already been imported",full);
    error(ERROR,string);
    return FALSE;
  } 

  if (infolevel>=NOTE && !is_bound) {
    sprintf(string,"importing from file '%s'",full);
    error(NOTE,string);
  }
  return TRUE;
}


FILE *open_library(char *name,char **fullreturn,int without) /* search and open a library */
{
  static char full[200];
  char unquoted[200];
  char *p;
  FILE *lib;
  int i;
  char *trail;

  if (fullreturn) *fullreturn=full;

  for(p=name;strchr(" \"'`",*p);p++) if (!*p) break;
  strncpy(unquoted,p,200);
  for(;!strchr(" \"'`",*p);p++) if (!*p) break;
  if (*p) unquoted[p-name-2]='\0';
  name=unquoted;
  if (strchr(name,'.')) {
    sprintf(string,"library name '%s' contains '.'",name);
    error(ERROR,string);
    return NULL;
  }
  if (!strcmp(name,"main")) {
    if (is_bound) return NULL;
    error(ERROR,"invalid library name 'main'");
    return NULL;
  }

  /* search local */
  trail=".yab";
  for(i=0;i<2;i++) {
    strcpy(full,name);
    if (!strchr(full,'.')) strcat(full,trail);
    lib=fopen(full,"r");
    if (lib) return lib;
    trail="";
    if (!without) break;
  }
  
  /* search in global location */
  trail=".yab";
  for(i=0;i<2;i++) {
    strcpy(full,library_path);
    if (full[0] && !strchr("\\/",full[strlen(full)-1])) {
#ifdef UNIX
      strcat(full,"/");
#else
      strcat(full,"\\");
#endif
    }     
    strcat(full,name);
    if (!strchr(full,'.')) strcat(full,trail);
    lib=fopen(full,"r");
    if (lib) return lib;
    trail="";
    if (!without) break;
  }

  sprintf(string,"couldn't open library '%s'",full);
  error(ERROR,string);
  return NULL;
}


void switchlib(void) /* switch library, called by bison */
{
  if (include_stack_ptr<0) return;
  if (infolevel>=DEBUG) {
    sprintf(string,"switching from '%s' to '%s'",currlib->s,libfile_stack[include_stack_ptr]->s);
    error(DEBUG,string);
  }
  currlib=libfile_stack[include_stack_ptr];
  yylineno=currlib->lineno;
  inlib=(include_stack_ptr>0);
}


